// This is the Common JS file where we have moved all the JS functions from Global Common Web template.
function disableClickOnCheckbox(e){
	e.stopPropagation(); 
	return false;
}   
//let	PCHJS = {};
if(typeof(PCHJS) != 'undefined'){  
	console.log("PCH-Common.js has already been loaded.")
} 
else {  
	PCHJS= {}; 

	PCHJS.Common={};
	PCHJS.Common.CurrentLang = "EN"; //defaulting to "EN", other possible value is "FR"
	PCHJS.Common.IsModal = false; //It will be true if current context is that of a Modal dialog. currently it happens when this JS file is being referenced from "Main – Modal SG Form" web template.
	PCHJS.Common.EscapeHtml = (str) =>   str.replace(/"/g, '\"').replace(/'/g, "\'");
	PCHJS.Common.HTTP = {};
	PCHJS.Common.HTTP.GetQueryString = () => // replaces getQueryString()
	{
		//This function returns a JSON object with all the query strign parameters as keys & their respective values as those key's values.
		const loc = PCHJS.Common.IsModal? window.parent.location : window.location ;
		const searchParams = new URLSearchParams(loc.search.replace('?', ''));
		return Object.fromEntries(searchParams);	
	}
	/***********************
	* Numeric
	************************/
	PCHJS.Common.Number = {};
	PCHJS.Common.Number.IsNumber = value =>
	{
		return !isNaN(value) ;
	}
	PCHJS.Common.Number.ToString = (value, places=0) => // replaces standardizeNumberFormat(numberToStandardize) 
	{
		//This function returns 0 if value is not truthy otherwise it retruns corresponding rounded integer, as string, if value is a valid float otherwise it returns the value itself.
		if(value) // not null, undefiend, NaN, empty, 0, false
		{
			if(PCHJS.Common.Number.IsNumber(value))
			{
				return Number.parseFloat(value).toFixed(places);
			}
			else
			{
				const numString = value.toString();
				const numFloat = PCHJS.Common.CurrentLang == "FR"? parseFloat(numString.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(numString.replace(/[^\d\.]/g, '')) ;
				if(numFloat) // not null, undefiend, NaN, empty, 0, false
				{
					return numFloat.toFixed(places);
				}
				else
				{
					return numString;
				}
			}
		}
		else
		{
			return 0;
		}
	}
	PCHJS.Common.Number.Round=(strValue, places=2) => {  
		strValue = strValue == null || strValue.trim() == '' ? '0':strValue ;
		return Math.round(Math.pow(10,places)* (PCHJS.Common.CurrentLang == "FR"? parseFloat(strValue.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(strValue.replace(/[^\d\.]/g, ''))))/Math.pow(10,places) 
	} ;
	PCHJS.Common.Number.GetRoundedInLocale=(numValue, places=2) =>{
		const locale = PCHJS.Common.CurrentLang == "FR"?"fr-CA":"en-CA";
		return PCHJS.Common.Number.Round(numValue.toLocaleString(locale), places).toLocaleString(locale);
	}
	PCHJS.Common.String = {};
	PCHJS.Common.String.Reverse = value => value.split("").reverse().join("");
	PCHJS.Common.UI = {};
	PCHJS.Common.UI.ReplaceDateFormatErrorMessage = (dateControlObj, field, message) => 
	{
		var messageVal= dateControlObj.errormessage;
		let searchChar = field+">";
		let result = messageVal.lastIndexOf(searchChar);
		let value = messageVal.substring(0, (result + searchChar.length));

		messageVal = PCHJS.Common.EscapeHtml(value) + message + "</a>"
		dateControlObj.errormessage =messageVal;
	}
	PCHJS.Common.UI.SetInputFilter = (textbox, inputFilter) => // replaces setInputFilter(textbox, inputFilter)
	{
		//This function ensures that if "textbox" is set to a value which doesn't satisfy the logic setforth in inputFilter callback function, it gets reverted to the old/empty value.
		["input", "keydown", "keyup", "mousedown", "mouseup", "select", "contextmenu", "drop"].forEach(
			function(event) 
			{
				textbox.addEventListener(event, function() 
				{
					if (inputFilter(this.value)) 
					{
						  this.oldValue = this.value;
						  this.oldSelectionStart = this.selectionStart;
						  this.oldSelectionEnd = this.selectionEnd;
					} else if (this.hasOwnProperty("oldValue")) 
					{
						this.value = this.oldValue;
						this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
					} 
					else 
					{
						this.value = "";
					}
				});
			}
		);
	};
	PCHJS.Common.UI.CheckEmptySetZero = (field) => //replaces checkNull(field)
	{
		if ($("#" + field).val() == null || $("#" + field).val() == "")
		{
			$("#" + field).val("0");
		}
	};
	PCHJS.Common.UI.EnsureNumericOnly = (fieldName,regexEN = /^[\d\,]*[\.]?[\d]*$/,regexFR = /^[\d\s]*[\,]?[\d]*$/, setZeroIfEmpty=true) => // replaces numericOnly(fieldName,regExEN,regExFR)
	{
		//This function ensures that if "fieldName" is set to a value which doesn't satisfy the En/Fr regular expressions then it gets reverted to the old/empty value.
		const regex = PCHJS.Common.CurrentLang == "FR"?regexFR:regexEN;
		PCHJS.Common.UI.SetInputFilter(document.getElementById(fieldName), value=>regex.test(value) );
		if(setZeroIfEmpty)
		{
			$("#"+fieldName).change(
				function() { PCHJS.Common.UI.CheckEmptySetZero(fieldName);}
			);
		}
	};
	PCHJS.Common.UI.FormatNumber = fieldName => //replaces formatNum(fieldName)
	{
		const locale = PCHJS.Common.CurrentLang == "FR"?"fr-CA":"en-CA";
		if($('#' + fieldName).val() != "")
		{
			$('#' + fieldName).val(parseInt(PCHJS.Common.Number.ToString($('#' + fieldName).val())).toLocaleString(locale));
		}
		else
		{
			$('#' + fieldName).val(0);
		}
	};
	PCHJS.Common.UI.FormatDate = fieldValue => //replaces formatDate(dateVal)
	{
		if(PCHJS.Common.CurrentLang == "FR")
		{
			let parsed = fieldValue.match(/(\d{2})\/(\d{2})\/(\d{4})/);
			return `${parsed[3]}-${parsed[2]}-${parsed[1]}`;
		}
		else
		{
			return (new Date(fieldValue)).toString("yyyy-MM-dd");
		}
	};
	PCHJS.Common.UI.AddRequiredLabel = (fieldName, isAddNotRemove) => //replaces formatDate(dateVal)
	{
		const isCheckbox = $("#" + fieldName ).closest("td").is(".checkbox-cell");
		const labelControl = $("#" + fieldName + "_label");
		const infoDiv = $("#" + fieldName + "_label").closest("div.info");
		if(isCheckbox)
		{
			//isAddNotRemove?$("#" + fieldName ).addClass("required"):$("#" + fieldName ).removeClass("required");
			isAddNotRemove?infoDiv.addClass("required"):infoDiv.removeClass("required");
		}
		else
		{
			
			isAddNotRemove?labelControl.addClass("required"):labelControl.removeClass("required");
		}
	};
	PCHJS.Common.UI.UpdateCharCounter = (fieldName, maxLength, trailingLabel='') => //replaces addCharCounterOnChange(field, maxLength)
	{
		//trailingLabel should be fed with {{snippets['Label/CharactersRemaining']}}
		if(!trailingLabel)
		{
			trailingLabel = PCHJS.Common.CurrentLang == "FR"?"caractères restants":"characters remaining";
		}
		const charCountRemains =maxLength - $("#" + fieldName).val().length;
		$(`<span id="chars${fieldName}" aria-live="polite" aria-atomic="true">(${charCountRemains} ${trailingLabel})</span>`).insertBefore($("#" + fieldName));
		$("#" + fieldName).keyup(function () 
		{
			let length = maxLength - $(this).val().length;
			
			$(`#chars${fieldName}`).text(`(${length} ${trailingLabel})`);
		});
	};
	PCHJS.Common.UI.AppendFormSubHead = (headEN,headFR) =>
	{
			const head = PCHJS.Common.CurrentLang == "FR"?headFR:headEN;
			$(".page-header>h1").after(`<h3>${head}</h3>`);
			const pageHeaderAriaLabel = $(".page-header>div[aria-roledescription=heading]").attr("aria-label");
			$(".page-header>div[aria-roledescription=heading]").attr("aria-label", `${pageHeaderAriaLabel} - ${'head'}` )
	};
	PCHJS.Common.UI.AppendFormSubHeadToPageCopy = (headEN,headFR) =>
	{
			const head = PCHJS.Common.CurrentLang == "FR"?headFR:headEN;
			if($(".page-copy h1").siblings("p:not(:empty)").length==0) // i.e. page copy does not have subheading defined on its own
			{
				$(".page-copy h1").after(`<h3>${head}</h3>`);
			}
	};
	PCHJS.Common.UI.AppendFormSubHeadToCDTSPage = (headEN,headFR) =>
	{
			const head = PCHJS.Common.CurrentLang == "FR"?headFR:headEN;
			$("main h1").first().after(`<p>${head}</p>`);
			
	};
	PCHJS.Common.UI.$GetTableObject = (tableId, tableData) => {
		/*const tableData = 
		{ 
			"headerRow":["Myheader1", "Myheader2"],
			"rows":[
				["MyrowHead1", {"MyId1":"MyValue1"}],
				["MyrowHead2", {"MyId2":"MyValue2"}],
				["MyrowHead2", {"MyId3":"MyValue3"}],
			]
		};*/
		const $theTable = $("<table>").attr("id",tableId).addClass("table").addClass("table-striped");
		const $theTableHeader = $("<thead>").css("background","lightgray");
		tableData.headerRow.forEach((h)=>$theTableHeader.append(`<th style="text-align:center;padding:8px;">${h}</th>`));
		const $theTableBody = $("<tbody>");
		tableData.rows.forEach((r)=>{
			const $theTableRow = $("<tr>");
			r.forEach( (d,i)=> {
				if(i==0)
				{
					const tdStyle= "font-weight:600;";				
					$theTableRow.append(`<td  style="${tdStyle}">${d}</td>`);
				}
				else{
					const tdStyle= "text-align:center;";
					const tdId = Object.keys(d)[0];
					$theTableRow.append(`<td id="${tdId}" style="${tdStyle}">${d[tdId]}</td>`);
				}
				
			});
			$theTableBody.append($theTableRow);
		});
		return $theTable.append($theTableHeader).append($theTableBody);
		
		
	};
	PCHJS.Common.UI.FormatCurrencyWholeNumber = intValue => {
		const locale = PCHJS.Common.CurrentLang == "FR"?"fr-CA":"en-CA";
		const strValue = parseInt(intValue).toLocaleString(locale);
		return PCHJS.Common.CurrentLang == "FR"?`${strValue} $`:`$${strValue}`;
	}
	/***********************
	* Set/Clear Value
	************************/
	PCHJS.Common.UI.SetFieldValue = (fieldName, fieldType, fieldValue, entityName, recordName) => //replaces SetFieldValue
	{
		try
		{
			fieldType = fieldType.toLowerCase();
			switch(fieldType)
			{
				case "lookup":
					$("#" + fieldName + "_name").val(recordName);
					$("#" + fieldName).val(fieldValue);
					$("#" + fieldName + "_entityname").val(entityName);
					break;
				default:
					$("#" + fieldName).val(fieldValue);
					break;
			}
		}
		catch(err)
		{
			console.error("Error ToggleFieldEnabled: " + err.message);
			return;
		}
	};
	PCHJS.Common.UI.ClearFieldValue = (fieldName, fieldType) => //replaces ClearFieldValue
	{
		PCHJS.Common.UI.SetFieldValue(fieldName, fieldType, "", "", "");
	};
	/************************
	* Required/Non Required
	************************/
	PCHJS.Common.UI.GetFieldRequiredGenericMessage = (fieldName) => {
		const fieldLabel = $(`#${fieldName}_label`).text();
		return PCHJS.Common.CurrentLang=="EN"?`${fieldLabel} is a requried field.`:`Le champ ${fieldLabel} est obligatoire.`; 
	};
	PCHJS.Common.UI.SetFieldAsRequired = (fieldName,customErrorMessage, isNumeric=false) => //replaces SetFieldAsRequired(fieldName,customErrorMessage)
	{
		
		if (typeof (Page_Validators) == 'undefined') return;
		//do nothing if validator already exists
		for (i = 0; i < Page_Validators.length; i++) {
			if (Page_Validators[i].id == "RequiredFieldValidator" + fieldName) {
				return;
			}
		}
		if ($("#" + fieldName).length > 0 && $("#" + fieldName + "_label").length > 0) {
			$("#" + fieldName).prop("required", true);
			PCHJS.Common.UI.AddRequiredLabel(fieldName,true);
			/*$("#" + fieldName).closest(".control").prev().addClass("required");
			
			$("#" + fieldName + "_label").addClass('required');
			$("#" + fieldName + "_label").wrapInner('<span class="field-name"></span>');

			if(!$("#" + fieldName + "_label").closest("div").hasClass("required"))
				$("#" + fieldName + "_label").closest("div").addClass("required");
			*/
			// Create new validator object
			var Requiredvalidator = document.createElement('span');
			Requiredvalidator.style.display = "none";
			Requiredvalidator.id = "RequiredFieldValidator" + fieldName;
			Requiredvalidator.controltovalidate = fieldName;
			if(customErrorMessage){
			 //  console.log("custom label for:"+fieldName);
			   Requiredvalidator.errormessage = "<a href='#" + fieldName + "_label'>" + customErrorMessage +"</a>";
			}else{
				//const fieldLabel = $(`#${fieldName}_label`).text();
				//const genericRequiredErrorText = PCHJS.Common.CurrentLang=="EN"?`${fieldLabel} is a requried field.`:`Le champ ${fieldLabel} est obligatoire.`;
				const genericRequiredErrorText = PCHJS.Common.UI.GetFieldRequiredGenericMessage(fieldName);
			   Requiredvalidator.errormessage = "<a href='#" + fieldName + "_label'>" + genericRequiredErrorText +"</a>";
			}
			Requiredvalidator.initialvalue = "";
			Requiredvalidator.evaluationfunction = function () {
				var fieldControl = $("#" + fieldName);
				//handle code component masks
				if($("#" + fieldName + "_Container #InputMaskControl input").length > 0){
					let currentInput = $("#" + fieldName + "_Container #InputMaskControl input").val();
					currentInput = currentInput.replaceAll(" ", "");
					currentInput = currentInput.replaceAll("_","");
					currentInput = currentInput.replaceAll("\"", "");
					currentInput = currentInput.replaceAll("(", "");
					currentInput = currentInput.replaceAll(")", "");
					currentInput = currentInput.replaceAll("-", "");
					if(!currentInput){
						return false;
					}
				}
				if (fieldControl.is("span")) {
					var value0 = $("#" + fieldName + "_0").prop("checked");
					var value1 = $("#" + fieldName + "_1").prop("checked");
					if (value0 == false && value1 == false) {
						return false;
					} else {
						return true;
					}
				}
				else {
					var value = $("#" + fieldName).val();
					const numFloat = PCHJS.Common.CurrentLang == "FR"? parseFloat(value.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(value.replace(/[^\d\.]/g, '')) ;
					if (value == null || value == "" || value == "\"\"" || (isNumeric && (isNaN(parseFloat(numFloat)) || parseFloat(numFloat)==0 ) ) ) {
						return false;
					} else {
						return true;
					}
				}
			};

			// Add the new validator to the page validators array
			Page_Validators.push(Requiredvalidator);
		}
	};
	PCHJS.Common.UI.SetFieldAsNonRequired = (fieldName) => //replaces SetFieldAsNonRequired
	{
		if (typeof (Page_Validators) == 'undefined') return;

		if ($("#" + fieldName) != undefined) {
			$("#" + fieldName).prop('required', false);
			PCHJS.Common.UI.AddRequiredLabel(fieldName,false);
			/*
			$("#" + fieldName).closest(".control").prev().removeClass("required");
			$("#" + fieldName).closest(".control").removeClass("required");
			

			$("#" + fieldName + "_label").removeClass('required');
			$("#" + fieldName + "_label").closest("div.info").removeClass('required');
			$("#" + fieldName + "_label").html($("#" + fieldName + "_label > span.field-name").html());
			$("#" + fieldName + "_label").wrapInner('<span class="field-name"></span>');
			*/
			for (i = 0; i < Page_Validators.length; i++) {
				if (Page_Validators[i].id == "RequiredFieldValidator" + fieldName) {
					// Remove the current field's 'Required' validator from 'Page_Validators' array
					Page_Validators.splice(i, 1);

					$("#RequiredFieldValidator" + fieldName).remove();
				}
			}
		}
		
	};
	PCHJS.Common.UI.SetSubgridAsRequired = (subgridName, errorMessage, evalFunction, showSubgridLabel = true,increaseHeaderSize, globalRequiredText) => //replaces SetSubgridAsRequired(subgridName, errorMessage_EN, errorMessage_FR, evalFunction, showSubgridLabel = true,increaseHeaderSize)
	{
		//errorMessage_EN, errorMessage_FR input params are being replaced now with a single param errorMessage which should be fed with snippet {{snippets['Global/RequiredError/SubGrid']}}
		//globalRequiredText should be fed with {{snippets["Global/Required"]}}
		if (typeof (Page_Validators) == 'undefined') return;
		//do nothing if validator already exists
		for (i = 0; i < Page_Validators.length; i++) {
			if (Page_Validators[i].id == "RequiredSubgridValidator" + subgridName) {
				return;
			}
		}
		
		if ($("#" + subgridName).length > 0 && (!showSubgridLabel || $("label[for='" + subgridName + "']").length > 0)) {
			$("#" + subgridName).attr("required", "required");
			$("#" + subgridName).closest(".control").prev().addClass("required");
			
			$("label[for='" + subgridName + "']").addClass('required');
			$("label[for='" + subgridName + "']").append("&nbsp;");
			$("label[for='" + subgridName + "']").append('<strong class="required">'+globalRequiredText+'</strong>');

		  
			//add id so we can create an anchor tag to the label when not valid
			$("label[for='" + subgridName + "']").attr('id', subgridName + "_label");

			// Create new validator object
			var Requiredvalidator = document.createElement('span');
			Requiredvalidator.style.display = "none";
			Requiredvalidator.id = "RequiredSubgridValidator" + subgridName;
			Requiredvalidator.controltovalidate = subgridName;
			if(showSubgridLabel == true){
			Requiredvalidator.errormessage = "<a href='#" + subgridName + "_label'>" + (showSubgridLabel ? $("#" + subgridName + "_label > span.field-name").html() + "&nbsp;" : "") + errorMessage + "</a>";
			}else{
			Requiredvalidator.errormessage = "<a href='#" + subgridName + "'>" + (showSubgridLabel ? $("#" + subgridName + "_label > span.field-name").html() + "&nbsp;" : "") + errorMessage + "</a>";
			}
			Requiredvalidator.initialvalue = "";

			if(evalFunction){
				Requiredvalidator.evaluationfunction = evalFunction
			}else{
				Requiredvalidator.evaluationfunction = function () {
					let numRows = $("#" + subgridName + " div.view-grid > table > tbody > tr").length

					return numRows > 0;
				};
			}

			// Add the new validator to the page validators array
			Page_Validators.push(Requiredvalidator);
		}
	};
	/************************
	* General Validation
	************************/

	PCHJS.Common.UI.AddFieldValidator = (fieldName, validatorPrefix, errorMessage, evalFunction, showFieldLabel = true, isoverridefullerrorlink= false) =>
	{
		//replaces AddFieldValidatorV2(fieldName, validatorPrefix, errorMessage, evalFunction, showFieldLabel = true, isoverridefullerrorlink= false) and
		//replaces AddFieldValidator(fieldName, validatorPrefix, errorMessage_EN, errorMessage_FR, evalFunction, showFieldLabel = true, isoverridefullerrorlink= false )
		
		if (typeof (Page_Validators) == 'undefined') return;
			
		//do nothing if validator already exists
		for (i = 0; i < Page_Validators.length; i++) {
			if (Page_Validators[i].id == validatorPrefix + fieldName) {
				return;
			}
		}
		if ($("#" + fieldName).length > 0 ) {
				
			// Create new validator object
			var Requiredvalidator = document.createElement('span');
			Requiredvalidator.style.display = "none";
			Requiredvalidator.id = validatorPrefix + fieldName;
			Requiredvalidator.controltovalidate = fieldName;
			if(!errorMessage && validatorPrefix.toLowerCase().contains('required'))
			{
				errorMessage = PCHJS.Common.UI.GetFieldRequiredGenericMessage(fieldName);
			}
			if(isoverridefullerrorlink || $("#" + fieldName + "_label").length == 0)
			   Requiredvalidator.errormessage = errorMessage;
				 
			else Requiredvalidator.errormessage = "<a href='#" + fieldName + "_label' >" + (showFieldLabel ? $("#" + fieldName + "_label").text() + "&nbsp;" : "") + errorMessage + "</a>";
		
			Requiredvalidator.initialvalue = "";
			Requiredvalidator.evaluationfunction = evalFunction;

			// Add the new validator to the page validators array
			Page_Validators.push(Requiredvalidator);
		
		}
	};
	PCHJS.Common.UI.AddRegExFieldValidator = (fieldName, regEx, errorMessage) =>
	{//replaces addRegExValidator(controlName,regEx,customErrorMessage)
		const evalFunc =  () => regex.test($(`#${fieldName}`).val());
		PCHJS.Common.UI.AddFieldValidator(fieldName,"RegExValidator",errorMessage,evalFunc );
	};
	PCHJS.Common.UI.AddPercentFieldValidator = (fieldNamePrimary,fieldNameSecondary, percentage, errorMessage, shouldBeLess=true,showFieldLabel = true) =>
	{//replaces addRegExValidator(controlName,regEx,customErrorMessage)
		const evalFunc =  () => {
			let primaryValue = $(`#${fieldNamePrimary}`).val();
			let secondaryValue = $(`#${fieldNameSecondary}`).val();
			const primaryFloat =   Math.round(100* (PCHJS.Common.CurrentLang == "FR"? parseFloat(primaryValue.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(primaryValue.replace(/[^\d\.]/g, ''    ))))/100 ;
			const secondaryFloat = Math.round(100* (PCHJS.Common.CurrentLang == "FR"? parseFloat(secondaryValue.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(secondaryValue.replace(/[^\d\.]/g, ''))))/100 ;
			return (shouldBeLess && primaryFloat <= percentage*0.01*secondaryFloat) || (!shouldBeLess && primaryFloat > percentage*0.01*secondaryFloat);
		};
		PCHJS.Common.UI.AddFieldValidator(fieldNamePrimary,"PercentValidator",errorMessage,evalFunc,showFieldLabel );
	};
	PCHJS.Common.UI.AddGroupFieldValidator = (fieldNames, errorMessage,minRequired , isNumeric=false) =>
	{//replaces addValidatorSomeMandatory(controlArray,customErrorMessage,minimumRequired)
		const evalFunc =  () => {
			let NumberOfValuesProvided = 0;
			fieldNames.forEach((fieldName) => {
				const value = $(`#${fieldName}`).val().trim();
				const numFloat = PCHJS.Common.CurrentLang == "FR"? parseFloat(value.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(value.replace(/[^\d\.]/g, '')) ;
				if (!(value == "" || value == "\"\"" || (isNumeric && (isNaN(parseFloat(numFloat)) || parseFloat(numFloat)==0 ) ) ))
				{
					NumberOfValuesProvided++;
				}
			});
			return NumberOfValuesProvided >= minRequired;
		};
		PCHJS.Common.UI.AddFieldValidator(fieldNames[0],"RequiredFieldValidator",errorMessage,evalFunc, false );
	};
	PCHJS.Common.UI.AddMinValueFieldValidator = (fieldName, errorMessage,minValue ) =>
	{//replaces addValidatorNumericGTNum(controlName,customErrorMessage,minNum, skipRequiredLabel)
		const evalFunc =  () => {

			const value = $(`#${fieldName}`).val().replace(',','.').trim();
			const numFloat = PCHJS.Common.CurrentLang == "FR"? parseFloat(value.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(value.replace(/[^\d\.]/g, '')) ;
			return numFloat >= minValue;
		};
		PCHJS.Common.UI.AddFieldValidator(fieldNames[0],"RequiredFieldValidator",errorMessage,evalFunc, false );
	};
	PCHJS.Common.UI.AddSumValueFieldValidator = (fieldNames, errorMessage,sumValue ) =>
	{
		const evalFunc =  () => {
			let sum = 0;
			fieldNames.forEach((fieldName) => {
				const value = $(`#${fieldName}`).val().trim();
				const numFloat = PCHJS.Common.CurrentLang == "FR"? parseFloat(value.replace(/[^\d\,]/g, '').replace(',', '.')) : parseFloat(value.replace(/[^\d\.]/g, '')) ;
				
				sum=sum+numFloat;
				
			});
			return sum >= sumValue;
		};
		PCHJS.Common.UI.AddFieldValidator(fieldNames[0],"SumFieldValidator",errorMessage,evalFunc, false );
	};
	PCHJS.Common.UI.RemoveFieldValidator = (fieldName, validatorPrefix) => //replaces RemoveFieldValidator(fieldName, validatorPrefix)
	{
		if (typeof (Page_Validators) == 'undefined') return;

		if ($("#" + fieldName) != undefined) {
			for (i = 0; i < Page_Validators.length; i++) {
				if (Page_Validators[i].id == validatorPrefix + fieldName) {
					// Remove the current field's validator from 'Page_Validators' array
					Page_Validators.splice(i, 1);

					$("#" + validatorPrefix + fieldName).remove();
				}
			}
		}
	};
	PCHJS.Common.UI.AddDateCompValidator = (controlDate1,controlDate2,customErrorMessage) => //replaces addDateCompValidator(controlDate1,controlDate2,customErrorMessage)
	{
		// validates that controlDate1 is before controlDate2
		if (typeof (Page_Validators) == 'undefined'){
			//if you do not have any validations going on out of the box then the ADX code will not load the Page_Validators function.  As such you wont be able to change validations.
			console.log("Page_Validators is undefined.  Add at least one mandatory field to your form to have it loaded automatically.");
			return;
		} 
		// Create new validator
		var newValidator = document.createElement('span');
		newValidator.style.display = "none";
		newValidator.id = "DateCompValidator" + controlDate2;
		newValidator.controltovalidate = "casetypecode";
		newValidator.errormessage = "<a href='#" + controlDate2 + "_label'>" + customErrorMessage +"</a>";
		newValidator.validationGroup = "";
		newValidator.initialvalue = "";
		newValidator.evaluationfunction = function () {
			var date1 = $("#" + controlDate1).val();
			var date2 = $("#" + controlDate2).val();
			if(date1 > date2){
				return false;
			}else{
				return true; 
			}
		};
		// Add the new validator to the page validators array:
		Page_Validators.push(newValidator);
		// Wire-up the click event handler of the validation summary link
		$("a[href='#" + controlDate2 + "_label']").on("click", function () { scrollToAndFocus(controlDate2 + '_label', controlDate2); });
	};
	PCHJS.Common.UI.AddDatesValidations = (controlDateStart, controlDateEnd, validationJSON , messageEndAfterStart, messageStartRange, messageEndRange, messageDiff, $startDateHelpTextElement, $endDateHelpTextElement ) =>
	{
		/*
		validation Json may have a subset of these properties
		{
			"minStart":"yyyyMMdd", // this will be the minimum start date possible, if it's blank or the property is not mentioned at all, no minimum validation is done on the start date.
			"maxStart":"yyyyMMdd", // this will be the maximum start date possible, if it's blank or the property is not mentioned at all, no maximum validation is done on the start date.
			"minEnd":"yyyyMMdd", // this will be the minimum end date possible, if it's blank or the property is not mentioned at all, no minimum validation is done on the end date.
			"maxEnd":"yyyyMMdd", // this will be the maximum end date possible, if it's blank or the property is not mentioned at all, no maximum validation is done on the end date.
			"minDiff":"",  //this will be the minmum difference in terms of number of days b/w start & end dates. If this node is mentioned, it must have numeric value & the presense of this node makes maxDiff node mandatory as well. 
			"maxDiff":"" //this will be the maximum difference in terms of number of days b/w start & end dates. If this node is mentioned, it must have numeric value & the presense of this node makes minDiff node mandatory as well. 
		}
		*/
		if (typeof (Page_Validators) == 'undefined')
		{
			//if you do not have any validations going on out of the box then the ADX code will not load the Page_Validators function.  As such you wont be able to change validations.
			console.log("Page_Validators is undefined.  Add at least one mandatory field to your form to have it loaded automatically.");
			return;
		}
			
		const locale = PCHJS.Common.CurrentLang=="EN"?"en-CA":"fr-CA";
		if(controlDateStart)
		{
			PCHJS.Common.UI.SetInputFilter(document.getElementById(`${controlDateStart}_datepicker_description`), function(value) {return /^[0-9]*-*[0-9]*-*[0-9]*$/.test(value); });
		}
		if(controlDateEnd)
		{
			PCHJS.Common.UI.SetInputFilter(document.getElementById(`${controlDateEnd}_datepicker_description`), function(value) {return /^[0-9]*-*[0-9]*-*[0-9]*$/.test(value); });
		}
		try
		{
			if(controlDateStart && controlDateEnd && messageEndAfterStart)
			{
				PCHJS.Common.UI.AddDateCompValidator(controlDateStart,controlDateEnd,messageEndAfterStart);
			}
		}
		catch(error) {}
		const dateRangeValidateFunction = (controlDate,message, suffix, $helpTextElement) =>
		{
			var dateVal = document.createElement('span');
			dateVal.style.display = "none";
			dateVal.id = `CustomDateFormatValidator_range_${controlDate}`;
			dateVal.controltovalidate = controlDate;
			dateVal.initialvalue = "";
			const validateMin = `min${suffix}` in validationJSON && !(!validationJSON[`min${suffix}`]);
			const validateMax = `max${suffix}` in validationJSON && !(!validationJSON[`max${suffix}`]);
			const validateRange = validateMin && validateMax;
			dateVal.errormessage = message;
			const dateFormatSuffix = PCHJS.Common.CurrentLang == "FR"? ` ("AAAA-MM-JJ")` : ` ("YYYY-MM-DD")` ;
			if(validateMin)
			{
				//const minFormatted = Date.parseExact(validationJSON[`min${suffix}`],'yyyyMMdd').toLocaleDateString(locale, {day: "numeric", month: "long", year:"numeric"});
				const minFormatted = Date.parseExact(validationJSON[`min${suffix}`],'yyyyMMdd').toString("yyyy-MM-dd") + dateFormatSuffix ;
				$(`#${controlDate}_label span.field-name`).text( $(`#${controlDate}_label span.field-name`).text().replaceAll(`[min${suffix}]`,minFormatted)  );		
				if($helpTextElement)
				{
					const helpText = $helpTextElement.html();
					$helpTextElement.html(helpText.replaceAll(`[min${suffix}]`,minFormatted));
					const ariaText = $helpTextElement.attr("aria-describedby").replaceAll(`[min${suffix}]`,minFormatted);
					$helpTextElement.attr("aria-describedby",ariaText);
				}				
				dateVal.errormessage = `<a href='#${controlDate}_label'>` + dateVal.errormessage.replaceAll(`[min${suffix}]`,minFormatted) + "</a>";
			}
			if(validateMax)
			{
				//const maxFormatted = Date.parseExact(validationJSON[`max${suffix}`],'yyyyMMdd').toLocaleDateString(locale, {day: "numeric", month: "long", year:"numeric"});
				const maxFormatted = Date.parseExact(validationJSON[`max${suffix}`],'yyyyMMdd').toString("yyyy-MM-dd") + dateFormatSuffix;
				$(`#${controlDate}_label span.field-name`).text( $(`#${controlDate}_label span.field-name`).text().replaceAll(`[max${suffix}]`,maxFormatted)  );	
				if($helpTextElement)
				{
					const helpText = $helpTextElement.html();
					$helpTextElement.html(helpText.replaceAll(`[max${suffix}]`,maxFormatted));
					const ariaText = $helpTextElement.attr("aria-describedby").replaceAll(`[max${suffix}]`,maxFormatted);
					$helpTextElement.attr("aria-describedby",ariaText);
				}			
				dateVal.errormessage = `<a href='#${controlDate}_label'>` + dateVal.errormessage.replaceAll(`[max${suffix}]`,maxFormatted) + "</a>";
			}
			dateVal.evaluationfunction = ()=>{
				const dateArr = $(`#${controlDate}_datepicker_description`).val().split("-")
				const date = new Date(dateArr[0],dateArr[1]-1,dateArr[2]);
				if(validateRange)
				{
					const dateMin = Date.parseExact(validationJSON[`min${suffix}`],'yyyyMMdd');
					const dateMax = Date.parseExact(validationJSON[`max${suffix}`],'yyyyMMdd');
					return !(date < dateMin) && !(date > dateMax);
				}
				else if(validateMin)
				{
					const dateMin = Date.parseExact(validationJSON[`min${suffix}`],'yyyyMMdd');
					return !(date < dateMin);
				}
				else if(validateMax)
				{
					const dateMax = Date.parseExact(validationJSON[`max${suffix}`],'yyyyMMdd');
					return !(date > dateMax);
				}
				
				
			};    
			if(validateMin || validateMax )
			{
				Page_Validators.push(dateVal);
			}
		}
		try
		{
			if(messageStartRange && controlDateStart)
			{
				dateRangeValidateFunction(controlDateStart,messageStartRange,'Start', $startDateHelpTextElement );
			}
		}
		catch(error) {}
		
		try
		{
			if( messageEndRange && controlDateEnd)
			{
				dateRangeValidateFunction(controlDateEnd,messageEndRange,'End', $endDateHelpTextElement);
			}
		}
		catch(error) {}
		
		try
		{
			if('maxDiff' in validationJSON && validationJSON.maxDiff && 'minDiff' in validationJSON && validationJSON.minDiff  && messageDiff && controlDateStart && controlDateEnd)
			{
				
				var dateVal = document.createElement('span');
				dateVal.style.display = "none";
				dateVal.id = `CustomDateFormatValidator_diff_${controlDateEnd}`;
				dateVal.controltovalidate = "casetypecode";
				dateVal.errormessage = `<a href='#${controlDateEnd}_label'>` + messageDiff + "</a>";
				dateVal.validationGroup = "";
				dateVal.initialvalue = "";
				dateVal.evaluationfunction = ()=>{
					var date1 = new Date($("#" + controlDateStart).val());
					var date2 = new Date($("#" + controlDateEnd).val());
					var Difference_In_Time = date2.getTime() - date1.getTime();
					var Difference_In_Days = Difference_In_Time / (1000 * 3600 * 24);
					Difference_In_Days = Math.round(Difference_In_Days);
					//console.log(Difference_In_Days);
					if(Difference_In_Days < validationJSON.minDiff){
						return false;
					}else if(Difference_In_Days > validationJSON.maxDiff){
						return false; 
					}
					else{
						return true;
					}
				};    
				Page_Validators.push(dateVal);
				// Wire-up the click event handler of the validation summary link
				$("a[href='#" + controlDateEnd + "_label']").on("click", function () { scrollToAndFocus(controlDateEnd + '_label', controlDateEnd); });
			}
		}
		catch(error) {}
		
	}; 
	/************************
	* Hide/Show
	************************/
	//Fields
	PCHJS.Common.UI.Field = {};
	PCHJS.Common.UI.Field.Show = name => $("#" + name).closest("td").show().siblings("td").show(); //replaces ShowField
	PCHJS.Common.UI.Field.Hide = name => $("#" + name).closest("td").hide().siblings("td").hide(); //replaces HideField
	//Sections
	PCHJS.Common.UI.Section = {};
	PCHJS.Common.UI.Section.Show = name => $("table[data-name='" + name + "']").parent().show(); //replaces ShowSection
	PCHJS.Common.UI.Section.Hide = name => $("table[data-name='" + name + "']").parent().hide(); //replaces HideSection
	/************************
	* Enable/Disable Fields
	************************/
	PCHJS.Common.UI.DateTime = {};
	PCHJS.Common.UI.DateTime.Disable = name => $('#' + name).siblings("div.datetimepicker").find("input, .input-group-addon").attr("readonly", true).css("cursor", "not-allowed").on("mousedown", function (e) { e.preventDefault(); return false; }); //replaces DisableDateTime
	PCHJS.Common.UI.DateTime.Enable = name => $('#' + name).siblings("div.datetimepicker").find("input, .input-group-addon").attr("readonly", false).css("cursor", "default").off("mousedown");  //replaces EnableDateTime

	PCHJS.Common.UI.Date = {};
	PCHJS.Common.UI.Date.SetPlaceholder = (fieldName) =>{
		const placeholderText = PCHJS.Common.CurrentLang == "FR"? "AAAA-MM-JJ": "YYYY-MM-DD";
		$(`#${fieldName}_datepicker_description`).attr('placeholder',placeholderText);
	}
	PCHJS.Common.UI.Lookup = {};
	PCHJS.Common.UI.Lookup.Disable = name => $("#" + name).prop("readonly", true).siblings("div.input-group-btn").find("button").prop("disabled", true); //replaces DisableLookup
	PCHJS.Common.UI.Lookup.Enable = name => $("#" + name).prop("readonly", false).siblings("div.input-group-btn").find("button").prop("disabled", false); //replaces EnableLookup
	PCHJS.Common.UI.Lookup.MakeNotEmptiable = name => $(`#${name}_lookupmodal button.remove-value`).hide();
	PCHJS.Common.UI.Checkbox = {};
	PCHJS.Common.UI.Checkbox.Disable = name => { //replaces DisableCheckbox
		//$("#" + name).prop("disabled", true);
		$(`:checkbox#${name}`).click(disableClickOnCheckbox);
		$(`label[for=${name}]`).click(disableClickOnCheckbox);
		$(`:checkbox#${name}`).css("opacity","0.5");
		$(`:checkbox#${name}`).css("cursor","not-allowed");
		$(`label[for=${name}]`).css("cursor","not-allowed");
		$(`:checkbox#${name}`).data("disabled","true");
	} 
	PCHJS.Common.UI.Checkbox.Enable = name => { //replaces EnableCheckbox
		//$("#" + name).prop("disabled", false); 
		$(`:checkbox#${name}`).unbind("click", disableClickOnCheckbox);
		$(`label[for=${name}]`).unbind("click", disableClickOnCheckbox);
		$(`:checkbox#${name}`).css("opacity","1");
		$(`:checkbox#${name}`).css("cursor","default");
		$(`label[for=${name}]`).css("cursor","default");
		$(`:checkbox#${name}`).removeData("disabled");
	}
	PCHJS.Common.UI.Checkbox.Toggle = name => { //replaces EnableCheckbox
		if($(`:checkbox#${name}`).data("disabled"))
		{
			PCHJS.Common.UI.Checkbox.Enable(name);
		}
		else
		{
			PCHJS.Common.UI.Checkbox.Disable(name);
		}
	}
	PCHJS.Common.UI.RadioButton = {};
	PCHJS.Common.UI.RadioButton.Disable = name => $("#" + name).find("input[type='radio']").prop("disabled", true); //replaces DisableRadioButton
	PCHJS.Common.UI.RadioButton.Enable = name => $("#" + name).find("input[type='radio']").prop("disabled", false); //replaces EnableRadioButton
	  
	PCHJS.Common.UI.Dropdown = {};
	PCHJS.Common.UI.Dropdown.Disable = name => $("#" + name).attr("readonly", true).css("pointer-events", "none"); //replaces DisableDropdown
	PCHJS.Common.UI.Dropdown.Enable = name => $("#" + name).attr("readonly", false).css("pointer-events", "auto"); //replaces EnableDropdown


	///////////////////// Common Disable function ////////////////////
	PCHJS.Common.UI.Disable = (fieldName, type = "none") => //replaces DisableField(fieldName, type = "none")
	{
		//Valid values for type: "date", "time", "datetime", "lookup", "checkbox", "radio", "radiobutton", "radiobuttons", "dropdown"
		try
		{
			type = type == "none" ? $("#" + fieldName).prop('nodeName').toLowerCase() : type.toLowerCase();
			switch (type) {
				case "date":
				case "time":
				case "datetime":
					PCHJS.Common.UI.DateTime.Disable(fieldName);
					break;
				case "lookup":
					PCHJS.Common.UI.Lookup.Disable(fieldName);
					break;
				case "checkbox":
					PCHJS.Common.UI.Checkbox.Disable(fieldName);
					break;
				case "radio":
				case "radiobutton":
				case "radiobuttons":
					PCHJS.Common.UI.RadioButton.Disable(fieldName);
					break;
				case "dropdown":
					PCHJS.Common.UI.Dropdown.Disable(fieldName);
					break;
				default:
					$("#" + fieldName).prop("readonly", true);
					break;
			}
		}
		catch (err) 
		{
			console.error("Error DisableField: " + err.message);
			return;
		}
	};
	///////////////////// Common Enable function ////////////////////
	PCHJS.Common.UI.Enable = (fieldName, type = "none") => //replaces EnableField(fieldName, type = "none")
	{
		//Valid values for type: "date", "time", "datetime", "lookup", "checkbox", "radio", "radiobutton", "radiobuttons", "dropdown"
		try
		{
			type = type == "none" ? $("#" + fieldName).prop('nodeName').toLowerCase() : type.toLowerCase();
			switch (type) 
			{
				case "date":
				case "time":
				case "datetime":
					PCHJS.Common.UI.DateTime.Enable(fieldName);
					break;
				case "lookup":
					PCHJS.Common.UI.Lookup.Enable(fieldName);
					break;
				case "checkbox":
					PCHJS.Common.UI.Checkbox.Enable(fieldName);
					break;
				case "radio":
				case "radiobutton":
				case "radiobuttons":
					PCHJS.Common.UI.RadioButton.Enable(fieldName);
					break;
				case "dropdown":
					PCHJS.Common.UI.Dropdown.Enable(fieldName);
					break;
				default:
					$("#" + fieldName).prop("readonly", false);
					break;
			}
		}
		catch (err) 
		{
			console.error("Error EnableField: " + err.message);
			return;
		}
	};

	//Get the totals from a subgrid by entity-name(table) & field-name(field)
	PCHJS.Common.UI.GetTableTotal = (table, field, grid="")=> { //replaces getTableTotal(table, field)
		
		const $parent = grid==""?$(document):$(`#${grid}`);
		if(grid!="" && $(`#${grid} tbody td.coib`).length >0) //editable grid is on
		{
			return $.map($(`#${grid} tbody td.coib input[data-schema=${field}]`), c=>parseInt($(c).val()==''?'0':$(c).val().replace(",",".").replace(/[^\d.-]/g, ''))).reduce((total,current)=>total+current,0 );
		}
		else
		{
			const type = typeof  $("tr[data-entity="+table+"] > td[data-attribute="+field+"]", $parent).first().data("value");
			if(type == 'object')
			{
				const sumComplex = $.map($("tr[data-entity="+table+"] > td[data-attribute="+field+"]", $parent), current => JSON.parse($(current).attr("data-value")).Value ).reduce((total,current)=>total+current,0 );
				return sumComplex;
			}
			else
			{
				const sumSimple = $.map($("tr[data-entity="+table+"] > td[data-attribute="+field+"]", $parent), current => $(current).data("value") ).reduce((total,current)=>total+current,0 );
				return sumSimple;
			}
		}
		
	} 

	PCHJS.Common.UI.ReplaceFieldsWithTable = (fieldIdArr, tableName) => //replaces replaceFieldsWithTable(fieldIdArr, tableName)
	{
		//this function accepts an array containing id values of n mumber of fields & renders a single row table with n number columns showing the values of these fields.
		//it also then hides those actual input fields within the DOM.
		$(`table[data-name=${tableName}]`).before(
			$("<table aria-relevant='additions' role='grid' class='table table-striped table-fluid table-responsive'>").
			append($("<tr>").wrap("<thead>").append(fieldIdArr.map( e => $("<th>").text( $(`#${e}_label>span`).text() ) )).parent()).
			append($("<tr>").wrap("<tbody>").append(fieldIdArr.map( e => $("<td>").attr("id",`table${e}`).text( $(`#${e}`).val() ) )).parent())
		).hide();
	};
	//removes all instances of ',' for English and ' ' for French
	PCHJS.Common.UI.StripChar = field => PCHJS.Common.CurrentLang = "EN"? field.toString().replace(/,/g, "") : field.toString().replace(/\s/g, "");  //replaces stripChar(field)
	//Adds all of the values in an array together and sets the 'targetField' to the resulting total 
	PCHJS.Common.UI.TotalArray = (array, targetField) => //replaces totalArray(array, targetField)
	{
		const total = array.reduce( (total, current) => { return total + parseFloat( PCHJS.Common.UI.StripChar( $("#"+current).val() )); },0);
		$("#"+targetField).val(total);
		PCHJS.Common.UI.FormatNumber(targetField);
		
	};
	/*
	//Adds leading and trailing * and required label
	PCHJS.Common.UI.FlipRequiredLabel = (controlName, requriedText , shouldAdd) => //replaces addRequiredLabel(controlName, yes)
	{
		if (shouldAdd) 
		{
			$("#" + controlName + "_label").html($("#" + controlName + "_label").html() + "<span class='required-input'> (" + requriedText + ") *</span>");
			$("#" + controlName + "_label").addClass("required");
		} else 
		{
			 //remove the formating
			 $("#" + controlName + "_label").removeClass("required");
			 //Clear the label value
		   $("#" + controlName + "_label").find("span").remove();  
		}
	};*/
	//Sets a date field with a provided value
	PCHJS.Common.UI.SetDateTimeFieldValue = (fieldId, dateValue) => //setDateTimeFieldValue(fieldId, dateValue)
	{
		//Get the submit field
		let $submitField = $("#" + fieldId); 
		//Get the display field
		let $displayField = $submitField.nextAll(".datetimepicker").children("input"); 
		//Get the display date format
		let dateFormat = $displayField.attr("data-date-format"); 
		//Set the submit field. Remember this needs to be in UTC and the format must be exact.
		$submitField.val(moment.utc(dateValue).format("YYYY-MM-DDTHH:mm:ss.SSSSSSS")); 
		//Set the display field using the page's date format
		$displayField.val(moment(dateValue).format(dateFormat));
	};
	//Adds decoration to a field
	PCHJS.Common.UI.AddDecoration = (controlName,decoration) => //replaces addDecoration(controlName,decoration)
	{
		const $control = $("#" + controlName);
		if($control.parent().attr('class') == undefined || $control.parent().attr('class').indexOf('input-group') == -1)
		{
			$control.wrap( "<div class='input-group'></div>" );
			const $inputGroupAddon = $("<span class='input-group-addon'>"+ decoration + "</span>");
			PCHJS.Common.CurrentLang = "EN"?$inputGroupAddon.insertBefore($control):$inputGroupAddon.insertAfter($control);        
		}
	};
	PCHJS.Common.UI.RedirectTO= (target,id="",appId="") => 
	{
		const protocolVal = window.location.protocol;
		const hostVal = window.location.host;
		const pathArray = window.location.pathname.split('/');
		//var id = "{{ request.params['id'] }}";
		//var appID = "{{ request.params['application_id'] }}";
		if(id == "" && sessionStorage.getItem("id"))
			id=sessionStorage.getItem("id");
		if(appID == "" && sessionStorage.getItem("application_id"))
			appID=sessionStorage.getItem("application_id");

		const URL = protocolVal+"//"+hostVal+"/"+pathArray[1]+"/"+target+"/?application_id="+appID+"&id="+id;
		window.location.assign(URL)
	}
	PCHJS.Grid ={};
	( function (){
		this.Grid =  function () {
			return{
			JsonData: [],
			Base64config:"",
			EntityCollection: [],
			AutoCompleteData: [],
			ColumnDataObject: [],
			TotalCountofLookupFields: 0,
			rowindex: 0,
			LookupSchemaName: "",
			Language: "",
			PortalJsonRequestField: "",
			PortalObjectFrameContent: "",
			Base64config:"",
			EntityCollection: [],
			AutoCompleteData: [],
			ColumnDataObject: [],
			TotalCountofLookupFields: 0,
			rowindex: 0,
			LookupFieldName: "",
			Language: "",
			PortalJsonRequestField: "",
			PortalObjectFrameContent: "",
			ParentEntityObject: {},
			RelatedEntityName:"",
			EditButtonLabel:null,
			SaveButtonLabel:null,
			CancelButtonLabel:null,
			SuccessMessage:null,
			GridInstructions: null,
			PCHEditableGridParentEntityMetaData: {},
			GridId: "",
			ColumnsToEnabledArray: [],
			GridEntityName: "",
			InstanceString: "",
			IsApplyValidationRules:false,
			IsEnableAddRow: false,
			IsEnableDeletion: false,
			IsInitialized:false,
			AtLeastEnabledOnce:false,
			async SetParentEntityMetaData(gridId, lookupFieldName)
			{
				this.LookupFieldName = lookupFieldName;
				const JsonGrid = JSON.parse(atob($("#" + gridId + " .entity-grid").attr("data-view-layouts")));
				if (JsonGrid[0]) {
					this.ParentEntityObject.LogicalName = JsonGrid[0].Source.LogicalName; //Parent Entity
					this.ParentEntityObject.Id = JsonGrid[0].Source.Id;
					this.ParentEntityObject.RelationshipName = JsonGrid[0].Relationship.SchemaName;
					this.RelatedEntityName = JsonGrid[0].Configuration.EntityName; //Child Entity
					this.Base64config = JsonGrid[0].Base64SecureConfiguration;
					this.PCHEditableGridParentEntityMetaData["EntityName"] = this.RelatedEntityName;
					this.PCHEditableGridParentEntityMetaData["EntitySetName"] = 
					await  ( async ()=>{
						const res = await PCHJS.Common.WebAPI.GetRecords("entities","entitysetname",`logicalname eq '${this.RelatedEntityName}'`);
						if(res.value && res.value.length>0){
							return res.value[0].entitysetname;
						}
						else
							return "";
					} ) ();
					this.PCHEditableGridParentEntityMetaData["ParentEntitySetName"] = 
					await  ( async ()=>{
						const res = await PCHJS.Common.WebAPI.GetRecords("entities","entitysetname",`logicalname eq '${this.ParentEntityObject.LogicalName}'`);
						if(res.value && res.value.length>0){
							return res.value[0].entitysetname;
						}
						else
							return "";
					} ) ();
					this.PCHEditableGridParentEntityMetaData["OdataNavigation"] = `${this.lookupFieldName}@odata.bind`;
				}
			},
			MakeGridEditable(gridid, enabledcolumsarray, instance ) {
				
				if($(".entity-form.form-readonly") && $(".entity-form.form-readonly").length > 0)
					return;
				//this.LookupFieldName = lookupFieldName;
				this.ColumnsToEnabledArray = enabledcolumsarray;
				this.InstanceString = instance;
				var _link = document.location.href.split('/');           
				this.Language = PCHJS.Grid.GetLanguage();

				$("<style>"+"#"+gridid+" .dropdown,"+"#"+gridid+" .create-action{display:none;}"+"#"+gridid+" select.required, "+"#"+gridid+" input.required{border-width: 0px 0px 1px 0px; border-color: red;box-shadow: inset 0 1px 1px rgba(211, 8, 12,.075), 0 0 2px rgba(211, 8, 12,.6);}</style>").appendTo("head");
				$(".grid-actions .pull-left").addClass("pull-right").removeClass("pull-left");

				if (!$("#" + gridid).find(".input-group").attr('class')) {
					$("<div class='view-toolbar grid-actions clearfix'><div class='pull-right toolbar-actions'><div class='input-group pull-right'></div></div></div>").insertBefore("#" + gridid + " .view-grid");
				}
				if(!$("#EditGrid_"+gridid).attr("class"))
				{
					$("#" + gridid).find(".input-group").append($("<button id='EditGrid_" + gridid + "' type='button'  class='btn btn-default pull-right' title='"+ (this.EditButtonLabel !=null? this.EditButtonLabel : (this.Language == 1036? "Modifier le tableau":"Edit table"))+"'><span class='fa fa-edit' aria-hidden='true'></span> "+ (this.EditButtonLabel !=null? this.EditButtonLabel : (this.Language == 1036? "Modifier le tableau":"Edit table"))+"</button>"));
					//$("#EditGrid_expenses_employees_freelancers").click( ()=> (async() => { await PCHExpenses.EnableInlineEditing('expenses_employees_freelancers','PCHExpenses'); })())

					$(`#EditGrid_${gridid}`).click( ()=> (
						async() => { 
							await this.EnableInlineEditing(gridid,instance); 
							$("td.coib input[data-type='System.Decimal']").each((i,e)=>{ PCHJS.Common.UI.EnsureNumericOnly($(e).attr("id")); })
						})());
				
				}
				
				if(!$("#grid_saving_"+gridid).attr("class"))
					$("#" + gridid).find(".input-group").append($("<div id='grid_saving_" + gridid + "' class='grid-saving coib_spacer view-loading message text-center' role='presentation' tabindex='0' style='display: none;'><span class='fa fa-spinner fa-spin' aria-hidden='true' style='display: inline-flex;'></span> "+(this.Language == 1036? "Sauvegarde":"Saving")+"...</div>"));
				
				if(this.IsEnableAddRow && !$("#AddRow_"+gridid).attr("class"))
					$("#" + gridid).find(".view-grid").append($("<div style='text-align: right;padding:8px;'><button id='AddRow_" + gridid + "' style='display:none;' type='button' onclick='"+instance+".AddRow.SetRow(\"" + gridid + "\"," + instance + ")' class='btn btn-default' title='"+(this.Language == 1036? "Ajouter":"Add")+"'><span class='fa fa-plus' aria-hidden='true'></span> "+(this.Language == 1036? "Ajouter":"Add")+"</button></div>"));

				if(!$("#Save_"+gridid).attr("class"))
					$("#" + gridid).find(".view-grid").append($("<button id='Save_" + gridid + "' style='display:none;float: right;' type='button' onclick='"+instance+".SaveAll(\"" + gridid + "\","+this.IsApplyValidationRules+")' class='btn btn-success pch_editable_save' title='"+ (this.SaveButtonLabel !=null? this.SaveButtonLabel : (this.Language == 1036? "Sauvegarder le tableau":"Save table"))+"' disabled=true><span class='fa fa-save' aria-hidden='true'></span> "+ (this.SaveButtonLabel !=null? this.SaveButtonLabel : (this.Language == 1036? "Sauvegarder le tableau":"Save table"))+"</button><span class='coib_spacer'></span>"));
				
				if(!$("#CancelGrid_"+gridid).attr("class"))
					$("#" + gridid).find(".input-group").append($("<button id='CancelGrid_" + gridid + "' style='display:none;' type='button' onclick='"+instance+".Cancel(\"" + gridid + "\")' class='btn btn-default' title='"+ (this.CancelButtonLabel !=null? this.CancelButtonLabel : (this.Language == 1036? "Annuler":"Cancel"))+"'><span class='fa fa-times' aria-hidden='true'></span> "+ (this.CancelButtonLabel !=null? this.CancelButtonLabel : (this.Language == 1036? "Annuler":"Cancel"))+"</button>"));
				
				if(this.GridInstructions !=null && !$("#grid_help_"+gridid).attr("class")){
					$("<div id='grid_help_"+gridid+"' class='help'>"+this.GridInstructions+"</div>").insertBefore($("#" + gridid).find(".input-group"));
				}
				this.IsInitialized = true;
			},
			RemoveEntryFromJSONObject: function() {
			},
			EnabelPortalRequestFrame: function(gridid) {  
			},
			GetAttributeTypes: async function (id) {
				var i = 0;
				var o = 0;
				var JsonGrid = JSON.parse(atob($("#" + id + " .entity-grid").attr("data-view-layouts")));
				var _lang = PCHJS.Grid.GetLanguage();

				if (JsonGrid[0]) {
					this.ParentEntityObject.LogicalName = JsonGrid[0].Source.LogicalName; //Parent Entity
					this.ParentEntityObject.Id = JsonGrid[0].Source.Id;
					this.ParentEntityObject.RelationshipName = JsonGrid[0].Relationship.SchemaName;
					this.RelatedEntityName = JsonGrid[0].Configuration.EntityName; //Child Entity
					this.Base64config = JsonGrid[0].Base64SecureConfiguration;
					if(Object.keys(this.PCHEditableGridParentEntityMetaData).length === 0){
						/*if(`{{settings['PCH/EditableGrids/ParentEntitiesMetadata']}}`.length >0){
							this.GetLiquidParentMetadata(`{{settings['PCH/EditableGrids/ParentEntitiesMetadata']}}`);
						}
						else
							return;*/
						this.PCHEditableGridParentEntityMetaData["EntityName"] = this.RelatedEntityName;
						this.PCHEditableGridParentEntityMetaData["EntitySetName"] = 
						await  ( async ()=>{
							const res = await PCHJS.Common.WebAPI.GetRecords("entities","entitysetname",`logicalname eq '${this.RelatedEntityName}'`);
							if(res.value && res.value.length>0){
								return res.value[0].entitysetname;
							}
							else
								return "";
						} ) ();
						this.PCHEditableGridParentEntityMetaData["ParentEntitySetName"] = 
						await  ( async ()=>{
							const res = await PCHJS.Common.WebAPI.GetRecords("entities","entitysetname",`logicalname eq '${this.ParentEntityObject.LogicalName}'`);
							if(res.value && res.value.length>0){
								return res.value[0].entitysetname;
							}
							else
								return "";
						} ) ();
						this.PCHEditableGridParentEntityMetaData["OdataNavigation"] = `${this.lookupFieldName}@odata.bind`;
					}
				}

				if (this.ColumnDataObject.length == 0) {
					for (i; i < JsonGrid[0].Columns.length; i++) {
						if (!JsonGrid[0].Columns[i].Metadata)
							continue;
			
						if (JsonGrid[0].Columns[i].Metadata.FormulaDefinition || JsonGrid[0].Configuration.EntityName.indexOf(JsonGrid[0].Columns[i].Metadata.EntityLogicalName) == -1 || (this.ColumnsToEnabledArray && this.ColumnsToEnabledArray.length>0 && this.ColumnsToEnabledArray.filter((_col)=> _col ==JsonGrid[0].Columns[i].Metadata.LogicalName).length==0)) {
							this.ColumnDataObject.push({
								"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
								"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
								"Skip": true,
								"Name": JsonGrid[0].Columns[i].Name,
								"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value
							});
							continue;
						} else if (JsonGrid[0].Columns[i].Metadata.Targets) {
							this.ColumnDataObject.push({
								"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
								"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
								"Targets": JsonGrid[0].Columns[i].Metadata.Targets[0],
								"Name": JsonGrid[0].Columns[i].Name,
								"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value
							});
							continue;
						} else if (JsonGrid[0].Columns[i].Metadata.OptionSet) {
							if (JsonGrid[0].Columns[i].Metadata.OptionSet.TrueOption) {
								var _options = [];
								_options.push({
									"Value": 1,
									"Label": JsonGrid[0].Columns[i].Metadata.OptionSet.TrueOption.Label.UserLocalizedLabel.Label
								});
								_options.push({
									"Value": 0,
									"Label": JsonGrid[0].Columns[i].Metadata.OptionSet.FalseOption.Label.UserLocalizedLabel.Label
								});
								this.ColumnDataObject.push({
									"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
									"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
									"Options": _options,
									"Name": JsonGrid[0].Columns[i].Name,
									"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value
								});
							} else {
								var _options = [];
								for (o = 0; o < JsonGrid[0].Columns[i].Metadata.OptionSet.Options.length; o++) {
									_options.push({
										"Value": JsonGrid[0].Columns[i].Metadata.OptionSet.Options[o].Value,
										"Label": JsonGrid[0].Columns[i].Metadata.OptionSet.Options[o].Label.LocalizedLabels.filter(function (label){
												return label.LanguageCode == PCHJS.Grid.GetLanguage()
											})[0].Label
									});
								}
								this.ColumnDataObject.push({
									"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
									"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
									"Options": _options,
									"Name": JsonGrid[0].Columns[i].Name,
									"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value
								});
								continue;
							}
						} else {
							var _columnobject = {};
							switch (JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value.toUpperCase()) {
								case "STRINGTYPE":
								case "MEMOTYPE":
									_columnobject = {
										"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
										"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
										"Name": JsonGrid[0].Columns[i].Name,
										"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value,
										"DataValidation": {
											"Format": JsonGrid[0].Columns[i].Metadata.Format,
											"MaxLength": JsonGrid[0].Columns[i].Metadata.MaxLength
										}
									};
									break;
								case "DECIMALTYPE":
								case "INTEGERTYPE":
								case "MONEYTYPE":
									//MaxValue MinValue
									_columnobject = {
										"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
										"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
										"Name": JsonGrid[0].Columns[i].Name,
										"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value,
										"DataValidation": {
											"MaxValue": JsonGrid[0].Columns[i].Metadata.MaxValue,
											"MinValue": JsonGrid[0].Columns[i].Metadata.MinValue
										}
									};
									break;
								default:
									_columnobject = {
										"LogicalName": JsonGrid[0].Columns[i].Metadata.LogicalName,
										"DataType": JsonGrid[0].Columns[i].Metadata.AttributeTypeName.Value,
										"Name": JsonGrid[0].Columns[i].Name,
										"Required": JsonGrid[0].Columns[i].Metadata.RequiredLevel.Value
									};
							}
							this.ColumnDataObject.push(_columnobject);
						}
					}
				}
			},
			GetLiquidParentMetadata: function (stringcontentsnippet){
				if(!stringcontentsnippet)
					return;
			
				var _metadata;
				try{
					_metadata = JSON.parse(stringcontentsnippet);
					if(_metadata.length>0){
						_metadata.forEach((_reference)=>{
							if(_reference.EntityName == this.RelatedEntityName)
							this.PCHEditableGridParentEntityMetaData = _reference;
						});
					}
				}
				catch(e){
					console.error("Was unable to retrieve the content snippet editable grid metadata");
				}
			},
			EnabelSaveAll: function() {
				if ($("#Save_" + this.GridId).attr("disabled"))
					$("#Save_" + this.GridId).attr("disabled", false);
			},
			async EnableInlineEditing(id, instance) {
				this.AtLeastEnabledOnce = true;
				this.GridId = id;
				this.GetAttributeTypes(id);
				this.JsonData = [];
				var _datatype = "",
					columnindex = 0,
					_trace = 0;
				this.GridEntityName = $("#" + id + " .view-grid tbody").children('tr:first').attr('data-entity');
				$("#EditGrid_" + id).hide();
				$("#" + id + " .view-grid").hide();
				$("#CancelGrid_" + id).fadeIn(100);
				$("#AddRow_" + id).fadeIn(100);
				$("#Save_" + id).fadeIn(100);
				$(".btn-primary, .submit-btn").attr("disabled", true);
				$("a.btn-primary").hide();
				$("#" + id).find(".view-grid th").each(function() {
					var a = $(this).find("a");
					a.hide();
					if (!$(this).find("label").text())
						$("<label>" + $(a).clone().find("span").remove().end().text() + "</label>").insertBefore(a);
				});
				var _localobject = this;
				$("#" + id).find(".view-grid tr").each(function() {
					columnindex = 0;
					$(this).find('td').each(function() {
						if ($(this).attr('aria-label') && $(this).attr('aria-label').indexOf('null') != -1) {
							$(this).hide();
							return true;
						}
						if (_localobject.ColumnDataObject.length > 0 && columnindex < _localobject.ColumnDataObject.length) {
							if (!_localobject.ColumnDataObject[columnindex].Skip) {
								switch (_localobject.ColumnDataObject[columnindex].DataType.toUpperCase()) {
									case "MONEYTYPE":
										$(this).hide();
										_localobject.Set.ConstructMoneytd($(this), _localobject.ColumnDataObject[columnindex], _localobject.rowindex, instance, columnindex);
										break;
									case "LOOKUPTYPE":
										break;
									case "STRINGTYPE":
										$(this).hide();
										_localobject.Set.ConstructStringtd($(this), _localobject.ColumnDataObject[columnindex], _localobject.rowindex, _localobject, columnindex);
										break;
									case "DECIMALTYPE":
										$(this).hide();
										_localobject.Set.ConstructDecimaltd($(this), _localobject.ColumnDataObject[columnindex], _localobject.rowindex, _localobject , columnindex);
										break;
									case "INTEGERTYPE":
										break;
									case "PICKLISTTYPE":
										$(this).hide();
										_localobject.Set.ConstructPicklisttd($(this), _localobject.ColumnDataObject[columnindex], _localobject.rowindex, instance, columnindex);
										break;
									case "BOOLEANTYPE":
										break;
									case "DATETIMETYPE":
										break;
									case "MEMOTYPE":
										break;
								}
								if (_localobject.ColumnDataObject[columnindex].DataValidation)
								_localobject.Validation.SetDataValidation(_localobject.ColumnDataObject[columnindex].LogicalName, _localobject.rowindex, "", _localobject.ColumnDataObject[columnindex].DataValidation);
		
							}
						}
						columnindex++;
					});

					if(_localobject.IsEnableDeletion && $(this).attr("data-id") && $(this).attr("data-id").length >0 && !$("#Add_Discard"+_localobject.rowindex).attr("class")){
						var _discarddropdown = "<td class='coib'><div id='Add_Discard" + _localobject.rowindex + "' class='action'><button class='btn btn-default delete' type='button' onclick='"+_localobject.InstanceString+".Set.DiscardExistingRow($(this),"+_localobject.InstanceString+");"+_localobject.InstanceString+".Save.DeleteRowPushToArray($(this),"+_localobject.InstanceString+");'><i class='glyphicon glyphicon-trash' aria-hidden='true'></i></button> </div></td>";
						$(_discarddropdown).appendTo($(this));
					}
					_localobject.rowindex++;
				});
				$("#" + id + " .view-grid").fadeIn(500);
			},
			Cancel: function(id) {
				$("#" + id + " .view-grid").hide();
				$("#" + id + " .view-grid th .required").remove();
				$("#" + id).find(".view-grid th").each(function() {
					var a = $(this).find("a");
					a.show();
					if ($(this).find("label").text())
						$(this).find("label").remove();
				});
				$("#" + id).find(".view-grid tr").each(function() {
					if ($(this).hasClass('coib'))
						$(this).remove();
					$(this).find('td').each(function() {
						if ($(this).hasClass('coib'))
							$(this).remove();
						else
							$(this).show();
					});
					if(!$(this).is(":visible"))
						$(this).show();
				});   
				$("#CancelGrid_" + id).fadeOut(100);
				$("#AddRow_" + id).fadeOut(100);
				$("#Save_" + id).hide();
				$("#EditGrid_" + id).fadeIn(500);
				$("#" + id + " .view-grid").fadeIn(500);
				if(!$("button.pch_editable_save").is(":visible")){
					$(".btn-primary, .submit-btn").attr("disabled", false);
					$("a.btn-primary").show();
				}

				$("#Save_" + id).attr("disabled", true);
				$("#AddRow_" + id).attr("disabled", false);

				this.Validation.RemoveAllGridValidationOnCancel();
				this.rowindex = 0;
			},
			SaveAll: function(id, issave) {          
				if (issave && !Page_ClientValidate('')) {
					$("#ValidationSummaryEntityFormControl_EntityFormView").insertBefore("#"+this.GridId);
					$("#ValidationSummaryEntityFormControl_EntityFormView .validation-header").text("The inline grid changes could not be submitted for the following reasons:")
					return;
				}
				console.log("saving..");
				$("#Save_" + id).attr("disabled", true);
				$("#"+id+" .btn-default").attr("disabled", true);
				$("#grid_saving_" + id).css("display", "inline");
				$("#" + id + " .entity-grid").find("tbody").hide();
				$("#liquid_form input").not("[id^=__]").not("[id^=EntityFormControl_]").not("[id^=btn]").not(".btn").not("td.coib *").first().trigger("change");
				this.TriggerAPICall(this.JsonData);
		
			},
			SubmissionErrorHandler: function(id, iserrorencountered) {
				var _error = $("<div id='"+id+"_MessagePanel_error' class='message alert alert-info alert-danger alert-danger' role='alert'><span id='MessageLabel' tabindex='0'><p class='text-danger'><span class='fa fa-exclamation-triangle' aria-hidden='true'></span> An unknown failure has occurred.<br/>Please try reloading the page can fix the error. Otherwise contact the help desk.</p></span></div>");
				var _success = $("<div id='"+id+"_MessagePanel_success' class='message alert alert-success' role='alert'><span id='MessageLabel' tabindex='0'>"+(this.SuccessMessage !=null? this.SuccessMessage : (this.Language == 1036? "FR Changes saved successfully.":"Changes saved successfully."))+" </span></div>");
		

				if (!iserrorencountered) {
					if (!$("#"+id+"_MessagePanel_success").hasClass("alert-success"))
						_success.insertBefore($("#" + id + " .grid-actions"));
					$("#"+id+"_MessagePanel_success").show().delay(10000).fadeOut();
					$("#grid_saving_" + id).hide();
					$("#" + id + " .entity-grid").find("tbody").show();
					$("#" + id + " .subgrid").trigger("refresh");
					this.Cancel(id);
					$("#"+ id+" .btn-default").attr("disabled", false);
				} else {

					if (!$("#"+id+"_MessagePanel_error").hasClass("alert-danger"))
						_error.insertBefore($("#" + id + " .grid-actions"));
					$("#"+id+"_MessagePanel_error").show().delay(15000).fadeOut();
					$("#grid_saving_" + id).hide();
					$("#" + id + " .entity-grid").find("tbody").show();
					this.Cancel(id);
					$("#EditGrid_" + id).attr("disabled", true);
					$("#"+ id+" .btn-default").attr("disabled", false);
				}
			},
			AddRow:{
				SetRow: function (id, instance){
					var _localobject = instance;
					var _row = "<tr data-entity='" + id + "' data-name='' class='coib' this.rowindex='" + _localobject.rowindex + "'>";
					//var _discarddropdown = "<td><div onclick='this.AddRow.RenderDiscardRow($(this))' id='Add_Discard" + this.rowindex + "' onkeydown='this.AddRow.ValidateRequiredFields($(this),true)' class='dropdown action'> <button class='btn btn-default btn-xs' data-toggle='dropdown' aria-label='action menu'> <span class='fa fa-chevron-circle-down fa-fw' aria-hidden='true'></span> </button> <ul class='dropdown-menu' style='/*position: fixed;*/'> <li> <a class='discard-link  launch-modal' onclick='this.AddRow.DiscardRow($(this))' role='menuitem' tabindex='-1' href='javascript:void(0)' title='Discard' aria-setsize='3' aria-posinset='3'> <span class='fa fa-ban' aria-hidden='true'></span>Discard </a> </li> </ul> </div></td>";
					var _discarddropdown = "<td><div id='Add_Discard" + _localobject.rowindex + "' onkeydown='"+_localobject.InstanceString+".AddRow.ValidateRequiredFields($(this),true,false,"+_localobject.InstanceString+")' class='action'><button class='btn btn-default delete' type='button' onclick='"+_localobject.InstanceString+".AddRow.DiscardRow($(this),"+_localobject.InstanceString+")'><i class='glyphicon glyphicon-trash' aria-hidden='true'></i></button> </div></td>";
					
					var i = 0,
						_tr = "";
					$("#AddRow_" + _localobject.GridId).attr("disabled", true);
					$("#AddRow_" + _localobject.GridId).attr("title", "You can only add one row at a time.\nThe highlighted required field(s) above need to completed first.");
					var _lookups = {};
					
					for (i; i < _localobject.ColumnDataObject.length; i++) {
						if (!_localobject.ColumnDataObject[i].Skip) {
							switch (_localobject.ColumnDataObject[i].DataType.toUpperCase()) {
								case "MONEYTYPE":
									if (_localobject.Validation.isRequired(_localobject.ColumnDataObject[i], _localobject.rowindex))
										_tr += "<td class='coib'><input type='text' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' placeholder='$' data-type='Microsoft.Xrm.Sdk.Money'  this.rowindex='" + this.rowindex + "' aria-label='" + _localobject.ColumnDataObject[i].Name + "' onchange='"+_localobject.InstanceString+".AddRow.ValidateRequiredFields($(this),false,false,"+_localobject.InstanceString+");this.EnabelSaveAll();"+_localobject.InstanceString+".Save.MoneyPushtoArray(event,"+_localobject.InstanceString+")' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class='text form-control required' placeholder='$' value=''></td>";
									else
										//_tr += "<td class='coib'><input type='text' id='" + this.ColumnDataObject[i].LogicalName + this.rowindex + "' placeholder='$' data-type='Microsoft.Xrm.Sdk.Money' this.rowindex='" + this.rowindex + "' aria-label='" + this.ColumnDataObject[i].Name + "' onchange='this.AddRow.ValidateRequiredFields($(this));this.EnabelSaveAll();this.Save.MoneyPushtoArray(event)' data-schema='" + this.ColumnDataObject[i].LogicalName + "' class='text form-control' placeholder='$' value=''></td>";
										_tr += "<td class='coib'><input type='text' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' placeholder='$' this.rowindex='" + _localobject.rowindex + "' onkeypress='return event.charCode >= 48 && event.charCode <= 57' aria-label='" + _localobject.ColumnDataObject[i].Name + "' placeholder='$' data-type='Microsoft.Xrm.Sdk.Money' oninput='"+_localobject.InstanceString+".EnabelSaveAll();' onchange='"+_localobject.InstanceString+".EnabelSaveAll();"+_localobject.InstanceString+".Save.MoneyPushtoArray(event,"+_localobject.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));$(this).val()==&#39;&#39; ? $(this).val(0):&#39;&#39;;' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control money' value=''/></td>";
										break;
								case "LOOKUPTYPE":
									break;
								case "STRINGTYPE":
									if (_localobject.Validation.isRequired(_localobject.ColumnDataObject[i], _localobject.rowindex))
										_tr += "<td class='coib'><input type='text' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' data-type='System.String'  this.rowindex='" + _localobject.rowindex + "' aria-label='" + _localobject.ColumnDataObject[i].Name + "'   onchange='"+_localobject.InstanceString+".AddRow.ValidateRequiredFields($(this),false,false,"+_localobject.InstanceString+");"+_localobject.InstanceString+".EnabelSaveAll();"+_localobject.InstanceString+".Save.StringPushtoArray(event,"+_localobject.InstanceString+")' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control required' value=''/></td>";
									else
										//_tr += "<td class='coib'><input type='text' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' data-type='System.String' this.rowindex='" + _localobject.rowindex + "' aria-label='" + _localobject.ColumnDataObject[i].Name + "'   onchange='this.AddRow.ValidateRequiredFields($(this));this.EnabelSaveAll();this.Save.StringPushtoArray(event)' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control' value=''/></td>";
										_tr += "<td class='coib'><input type='text' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "'  this.rowindex='" + _localobject.rowindex + "' aria-label='" + _localobject.ColumnDataObject[i].Name + "'  data-type='System.String' oninput='"+_localobject.InstanceString+".EnabelSaveAll();' onchange='"+_localobject.InstanceString+".EnabelSaveAll();"+_localobject.InstanceString+".Save.StringPushtoArray(event,"+_localobject.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control' value=''/></td>";
										break;
								case "DATETIMETYPE":
									break;
								case "DECIMALTYPE":
									if (_localobject.Validation.isRequired(_localobject.ColumnDataObject[i], _localobject.rowindex))
										_tr += "<td class='coib'><input type='text' style='width:100%' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' this.rowindex='" + _localobject.rowindex + "' "+( typeof (_localobject.ColumnDataObject[i].DataValidation.MaxValue) != 'undefined' ? ("max='"+_localobject.ColumnDataObject[i].DataValidation.MaxValue+"'"):"")+" "+( typeof (_localobject.ColumnDataObject[i].DataValidation.MinValue) != 'undefined' ? ("min='"+_localobject.ColumnDataObject[i].DataValidation.MinValue+"'"):"")+ "aria-label='" + _localobject.ColumnDataObject[i].Name + "' data-type='System.Decimal' oninput='"+_localobject.InstanceString+".EnabelSaveAll();' onchange='"+_localobject.InstanceString+".AddRow.ValidateRequiredFields($(this),false,false,"+_localobject.InstanceString+");"+_localobject.InstanceString+".EnabelSaveAll();"+_localobject.InstanceString+".Save.DecimalPushtoArray(event,"+_localobject.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control decimal required' value='0'/></td>";
									else
										_tr += "<td class='coib'><input type='text' style='width:100%' id='" + _localobject.ColumnDataObject[i].LogicalName + _localobject.rowindex + "' this.rowindex='" + _localobject.rowindex + "' "+( typeof (_localobject.ColumnDataObject[i].DataValidation.MaxValue) != 'undefined' ? ("max='"+_localobject.ColumnDataObject[i].DataValidation.MaxValue+"'"):"")+" "+( typeof (_localobject.ColumnDataObject[i].DataValidation.MinValue) != 'undefined' ? ("min='"+_localobject.ColumnDataObject[i].DataValidation.MinValue+"'"):"")+ "aria-label='" + _localobject.ColumnDataObject[i].Name + "' data-type='System.Decimal' oninput='"+_localobject.InstanceString+".EnabelSaveAll();' onchange='"+_localobject.InstanceString+".EnabelSaveAll();"+_localobject.InstanceString+".Save.DecimalPushtoArray(event,"+_localobject.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + _localobject.ColumnDataObject[i].LogicalName + "' class ='text form-control decimal' value='0'/></td>";
									break;
								case "INTEGERTYPE":
									break;
								case "PICKLISTTYPE":
									if (_localobject.Validation.isRequired(_localobject.ColumnDataObject[i], _localobject.rowindex))
										_tr += _localobject.Add.Set.AddPicklisttd(_localobject.ColumnDataObject[i], _localobject.rowindex, true);
									else
										_tr += _localobject.Add.Set.AddPicklisttd(_localobject.ColumnDataObject[i], _localobject.rowindex);
									break;
								case "BOOLEANTYPE":
									break;
								case "MEMOTYPE":
									break;
								default:
									_tr += "<td></td>";
							}
						} else {
							switch (_localobject.ColumnDataObject[i].DataType.toUpperCase()) {
								case "INTEGERTYPE":
									_tr += "<td data-type='System.Int32' data-attribute='" + _localobject.ColumnDataObject[i].LogicalName + "' data-value='' tabindex='0' data-th='' aria-label=''></td>";
									break;
								case "STRINGTYPE":
									_tr += "<td data-type='System.String' data-attribute='" + _localobject.ColumnDataObject[i].LogicalName + "' data-value='' tabindex='0' data-th='' aria-label=''></td>";
									break;
								default:
									_tr += "<td></td>";
							}
						}
						if (_localobject.ColumnDataObject[i].DataValidation)
							_localobject.Validation.SetDataValidation(_localobject.ColumnDataObject[i].LogicalName, _localobject.rowindex, "", _localobject.ColumnDataObject[i].DataValidation);
					}

					if($("#" + id + " tbody").length)
						$(_row + _tr + _discarddropdown + "</tr>").appendTo($("#" + id + " tbody"));
					else
						$("<tbody>"+_row + _tr + _discarddropdown + "</tr></tbody>").appendTo($("#" + id + " table"));

					if (_lookups.id) {
						if (_localobject.EntityCollection.length == 0)
							_localobject.Lookup.GetDataCollection(_lookups.Targets, _lookups.id);
						else
						_localobject.Lookup.PopulateDropDown(_lookups.id, _localobject.rowindex);
					}
					_localobject.rowindex++;
				},    
				RenderDiscardRow:function(event) {
					////console.log(event);
					// event.children("ul").css({
					//     "top": event.offset().top - $(document).scrollTop() + event.height(),
					//     "left": event.position().left
					// });
				},
				DiscardRow: function(event, instance) {
					var _tr = event.closest("td").parent();
					var _rowindex = _tr.attr("this.rowindex");
					_tr.find("td").each(function() {
						if ($(this).hasClass("coib")) {
							if ($(this).children("[data-type]")) {
								instance.Validation.RemoveValidation($(this).children("[data-type]").attr("id"));
							}
						}
					});
					instance.AddRow.ValidateRequiredFields(event, false, true,instance);
					_tr.remove();
					var _entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "rowindex", _rowindex);
					if (_entityIndex > -1)
						instance.JsonData.splice(_entityIndex, 1);

					if (instance.JsonData.length < 1) {
						$("#Save_" + instance.GridId).attr("disabled", true);
					}
					//instance.rowindex = instance.rowindex - 1; 
				},
				ValidateRequiredFields: function(event, onTab, onDiscard, instance) {
					var _tr = event.closest("td").parent(), _isvalidated = true;
						if (onDiscard)
							_tr = _tr.prev();
		
						var _rowindex = _tr.attr("this.rowindex");
						_tr.find("td").each(function () {

							if ($(this).hasClass("coib") && $(this).children().hasClass("required")) {

								if (!$(this).children().val()) {
									_isvalidated = false;
									return;
								}
							}
						});
						if (_isvalidated && (_tr.index() == _tr.parent().children().length - 1 || onDiscard)){
							$("#AddRow_" + instance.GridId).attr("title", "Add");
							$("#AddRow_" + instance.GridId).attr("disabled", false);
		
							if (_isvalidated && onTab)
								instance.AddRow.SetRow(instance.GridId, instance);
						}
						else {
							$("#AddRow_" + instance.GridId).attr("disabled", true);
							$("#AddRow_" + instance.GridId).attr("title", "You can only add one row at a time.\nThe highlighted required field(s) above need to completed first.");
						}
				}       
			},
			Set: {
				ConstructLookuptd: function(tdObject, columnobject, index) {
				   
				},
				ConstructMoneytd: function(tdObject, columnobject, index, instance, ColumnIndex) {
					if (tdObject.find("#" + (tdObject).attr('data-attribute') + index).attr('data-type')) {
						$("#" + (tdObject).attr('data-attribute') + index).parent().show();
						$("#" + (tdObject).attr('data-attribute') + index).val($(tdObject).text());
					} else {
						if ($(tdObject).text().length > 0)
							$("<td class='coib'><div class='input-group'>"+(PCHJS.Grid.GetLanguage() == 1033? "<span class='input-group-addon'>$</span>":"")+"<input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' this.rowindex='" + index + "' onkeypress='return event.charCode >= 48 && event.charCode <= 57' aria-label='" + columnobject.Name + "' data-type='Microsoft.Xrm.Sdk.Money' oninput='"+instance+".EnabelSaveAll();' onchange='"+instance+".EnabelSaveAll();"+instance+".Save.MoneyPushtoArray(event,"+instance+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));$(this).val()==&#39;&#39; ? $(this).val(0):&#39;&#39;;' data-schema='" + columnobject.LogicalName + "' class ='text form-control money' value='" + $(tdObject).data().value.Value + "'/>"+(PCHJS.Grid.GetLanguage() == 1036? "<span class='input-group-addon'>$</span>":"")+"</div></td>").insertAfter(tdObject);
						else
							$("<td class='coib'><input type='text' id='" + columnobject.LogicalName + index + "'  this.rowindex='" + index + "' onkeypress='return event.charCode >= 48 && event.charCode <= 57' aria-label='" + columnobject.Name + "' placeholder='$' data-type='Microsoft.Xrm.Sdk.Money' oninput='"+instance+".EnabelSaveAll();' onchange='"+instance+".EnabelSaveAll();"+instance+".Save.MoneyPushtoArray(event,"+instance+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));$(this).val()==&#39;&#39; ? $(this).val(0):&#39;&#39;;' data-schema='" + columnobject.LogicalName + "' class ='text form-control money' value=''/></td>").insertAfter(tdObject);
					}
					if (columnobject.Required == 2) {
						$("#" + columnobject.LogicalName + index).addClass("required");
						instance.Validation.SetValidation(columnobject.LogicalName, index, "", ColumnIndex);
					}
				},
				ConstructStringtd: function(tdObject, columnobject, index, instanceobj, ColumnIndex) {
					if (tdObject.find("#" + (tdObject).attr('data-attribute') + index).attr('data-type')) {
						$("#" + (tdObject).attr('data-attribute') + index).parent().show();
						$("#" + (tdObject).attr('data-attribute') + index).val($(tdObject).text());
					} else {
						if ($(tdObject).text().length > 0)
							$("<td class='coib'><input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' this.rowindex='" + index + "' aria-label='" + columnobject.Name + "' data-type='System.String' oninput='"+instanceobj.InstanceString+".EnabelSaveAll();' onchange='"+instanceobj.InstanceString+".EnabelSaveAll();"+instanceobj.InstanceString+".Save.StringPushtoArray(event,"+instanceobj.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + columnobject.LogicalName + "' class ='text form-control' value='" + $(tdObject).data().value + "'/>"+(PCHJS.Grid.GetLanguage() == 1036? "":"")+"</div></td>").insertAfter(tdObject);
						else
							$("<td class='coib'><input type='text' id='" + columnobject.LogicalName + index + "'  this.rowindex='" + index + "' aria-label='" + columnobject.Name + "'  data-type='System.String' oninput='"+instanceobj.InstanceString+".EnabelSaveAll();' onchange='"+instanceobj.InstanceString+".EnabelSaveAll();"+instanceobj.InstanceString+".Save.StringPushtoArray(event,"+instanceobj.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + columnobject.LogicalName + "' class ='text form-control' value=''/></td>").insertAfter(tdObject);
					}
					if (columnobject.Required == 2) {
						$("#" + columnobject.LogicalName + index).addClass("required");
						instanceobj.Validation.SetValidation(columnobject.LogicalName, index, "", ColumnIndex);
					}
				},
				ConstructPicklisttd: function (tdObject, columnobject, index, ColumnIndex) {
		
					var i = 0;
					var _options = "";
		
					//$(tdObject).parent().append("<td><input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' data-type='" + $(tdObject).attr('data-type') + "'  onchange='this.EnabelSaveAll();this.Save.StringPushtoArray(event)' data-schema='" + $(tdObject).attr('data-attribute') + "' class ='text form-control' value='" + $(tdObject).text() + "'/><input type='hidden' class ='text form-control' value='" + $(tdObject).parent().text() + "'/></td>");
					var _optionsetHtml = "<td class='coib' data-type='Microsoft.Xrm.Sdk.OptionSetValue' colspan='1' rowspan='1' class='clearfix cell picklist-cell'> <div id='' class='control'> <select name='" + columnobject.LogicalName + "' style='/*width:auto;*/' id='" + columnobject.LogicalName + index + "' data-schema='" + columnobject.LogicalName + "' data-type='" + columnobject.DataType + "' class='form-control picklist'" + " this.rowindex='" + index + "' aria-label='" + columnobject.Name + "' onchange='this.EnabelSaveAll();this.Save.PicklistPushtoArray(event);'> <option value='' label=' '> </option>";
		
					for (i = 0; i < columnobject.Options.length; i++) {
						_options += "<option value='" + columnobject.Options[i].Value + "'>" + columnobject.Options[i].Label + "</option>";
					}
					$(_optionsetHtml + _options + "</select> </div> </td>").insertAfter(tdObject);
					//}
		
					if (tdObject.attr('data-value')) {
						var _optionsetJson = JSON.parse(tdObject.attr('data-value'));
						$("#" + columnobject.LogicalName + index).val(_optionsetJson.Value);
					}
		
					if (columnobject.Required == 2) {
						$("#" + columnobject.LogicalName + index).addClass("required");
						instance.Validation.SetValidation(columnobject.LogicalName, index, "", ColumnIndex);
					}
					if (columnobject.DataValidation)
						instance.Validation.SetDataValidation(columnobject.LogicalName, index, "", columnobject.DataValidation);
		
				},
				ConstructBooleantd: function(tdObject, columnobject, index, ColumnIndex) {
					
				},
				ConstructDecimaltd: function(tdObject, columnobject, index, instanceobj, ColumnIndex) {
					if (tdObject.find("#" + (tdObject).attr('data-attribute') + index).attr('data-type')) {
						$("#" + (tdObject).attr('data-attribute') + index).parent().show();
						$("#" + (tdObject).attr('data-attribute') + index).val($(tdObject).text());
					} else {
						if ($(tdObject).text().length > 0)
							//$(tdObject).parent().append("<td><input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' data-type='" + $(tdObject).attr('data-type') + "' onchange='this.EnabelSaveAll();this.Save.MoneyPushtoArray(event)' data-schema='" + $(tdObject).attr('data-attribute') + "' class ='text form-control' value='" + $(tdObject).text() + "'/></td>");
							$("<td class='coib'><input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' this.rowindex='" + index + "' aria-label='" + columnobject.Name + "' data-type='System.Decimal' oninput='"+instanceobj.InstanceString+".EnabelSaveAll();' onchange='"+instanceobj.InstanceString+".EnabelSaveAll();"+instanceobj.InstanceString+".Save.DecimalPushtoArray(event,"+instanceobj.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + columnobject.LogicalName + "' class ='text form-control decimal' value='" + PCHJS.Common.Number.GetRoundedInLocale($(tdObject).data().value,2) + "'/>"+(PCHJS.Grid.GetLanguage() == 1036? "":"")+"</div></td>").insertAfter(tdObject);
						else
							//(tdObject).parent().append("<td><input type='text' id='" + $(tdObject).attr('data-attribute') + index + "' data-type='" + $(tdObject).attr('data-type') + "' onchange='this.EnabelSaveAll();this.Save.MoneyPushtoArray(event)' data-schema='" + $(tdObject).attr('data-attribute') + "' class ='text form-control' value='" + $(tdObject).text() + "'/></td>");
							$("<td class='coib'><input type='text' id='" + columnobject.LogicalName + index + "'  this.rowindex='" + index + "' aria-label='" + columnobject.Name + "' data-type='System.Decimal' oninput='"+instanceobj.InstanceString+".EnabelSaveAll();' onchange='"+instanceobj.InstanceString+".EnabelSaveAll();"+instanceobj.InstanceString+".Save.DecimalPushtoArray(event,"+instanceobj.InstanceString+");$(this).val($(this).val().replace(/^0+/, &#39;&#39;));' data-schema='" + columnobject.LogicalName + "' class ='text form-control decimal' value=''/></td>").insertAfter(tdObject);
					}
					if (columnobject.Required == 2) {
						$("#" + columnobject.LogicalName + index).addClass("required");
						instanceobj.Validation.SetValidation(columnobject.LogicalName, index, "", ColumnIndex);
					}
				},
				ConstructIntegertd: function(tdObject, columnobject, index, ColumnIndex) {
				   
				},
				ConstructDatetd: function(tdObject, columnobject, index, ColumnIndex) {
					
				},
				ConstructMemotd: function(tdObject, columnobject, index, ColumnIndex) {
					
				},
				DiscardExistingRow: function($event, instance) {
					
					$event.closest("tr").hide();     
					$event.closest("tr").find("td.coib").each(function() {
						if ($(this).children("[data-type]")) {
							instance.Validation.RemoveValidation($(this).children("[data-type]").attr("id"));
						}
					});
				}
			},
			Add: {
				Set: {
					AddPicklisttd: function(columnobject, index, required) {
						var i = 0, _options = "", _optionsetHtml = "";
						if (required)
							_optionsetHtml = "<td class='coib' data-type='Microsoft.Xrm.Sdk.OptionSetValue' colspan='1' rowspan='1' class='clearfix cell picklist-cell'><!-- <div id='' class='control'> --><select name='" + columnobject.LogicalName + "' id='" + columnobject.LogicalName + index + "' data-schema='" + columnobject.LogicalName + "' data-type='" + columnobject.DataType + "' class='form-control picklist required' this.rowindex='" + index + "' aria-label='" + columnobject.Name + "'  onchange='this.AddRow.ValidateRequiredFields($(this));this.EnabelSaveAll();this.Save.PicklistPushtoArray(event);'> <option value='' label=' '> </option>";
						else
							_optionsetHtml = "<td class='coib' data-type='Microsoft.Xrm.Sdk.OptionSetValue' colspan='1' rowspan='1' class='clearfix cell picklist-cell'><!-- <div id='' class='control'> --><select name='" + columnobject.LogicalName + "' id='" + columnobject.LogicalName + index + "' data-schema='" + columnobject.LogicalName + "' data-type='" + columnobject.DataType + "' class='form-control picklist' this.rowindex='" + index + "' aria-label='" + columnobject.Name + "'  onchange='this.AddRow.ValidateRequiredFields($(this));this.EnabelSaveAll();this.Save.PicklistPushtoArray(event);'> <option value='' label=' '> </option>";
						for (i = 0; i < columnobject.Options.length; i++) {
							_options += "<option value='" + columnobject.Options[i].Value + "'>" + columnobject.Options[i].Label + "</option>";
						}
						return _optionsetHtml + _options + "</select></td>";
					},
					AddBooleantd: function(columnobject, index, required) {
						
					}
				}
			},
			Save: {
				MoneyPushtoArray: function(event, instance) {
					var id = event.currentTarget.id,
						_entity = {},
						_attr = {},
						_entityIndex = 0,
						_attrIndex = 0;
					if ($("#"+instance.GridId+" #" + id).closest('tr').attr("data-id")) {
						_entity.Request = "PATCH";
						_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "Id", _entity.Id);
					} else {
						_entity.Request = "POST";
						_entity.rowindex = $("#"+instance.GridId+" #" + id).closest('tr').attr("this.rowindex");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "rowindex", _entity.rowindex);
						if (!_entity.ParentEntity) {
							_entity.ParentEntity = instance.ParentEntityObject;
						}
					}
					_entity.LogicalName = instance.GridEntityName;
					_entity.LocalAttributes = [];
					_attr.FieldType = "money";
					_attr.Schema = $("#"+instance.GridId+" #" + id).attr("data-schema");
					_attr.Value = $("#"+instance.GridId+" #" + id).val().replace("$","");
					if (_entityIndex == -1) {
						_entity.LocalAttributes.push(_attr);
						instance.JsonData.push(_entity);
					} else {
						_attrIndex = PCHJS.Grid.CheckEntries(instance.JsonData[_entityIndex].LocalAttributes, "Schema", _attr.Schema);
						if (_attrIndex == -1)
							instance.JsonData[_entityIndex].LocalAttributes.push(_attr);
						else
							instance.JsonData[_entityIndex].LocalAttributes[_attrIndex] = _attr;
					}
					console.log("money push to array instance.JsonData");
					console.log(instance.JsonData);
				},
				OnFocusOut: function(event) {
					
				},
				SaveMoney: function(event, instance) {
		
					var id = event.currentTarget.id;
						 _entity = {},
						 _attr = {},
						 _entityIndex = 0,
						 _attrIndex = 0;
					if ($("#"+instance.GridId+" #" + id).closest('tr').attr("data-id")) {
						_entity.Request = "PATCH";
						_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
						_entityIndex = PCHJS.Grid.CheckEntries(this.JsonData, "Id", _entity.Id);
					} else {
						_entity.Request = "POST";
						_entity.rowindex = $("#"+instance.GridId+" #" + id).closest('tr').attr("this.rowindex");
						_entityIndex = PCHJS.Grid.CheckEntries(this.JsonData, "rowindex", _entity.rowindex);
						if (!_entity.ParentEntity) {
							_entity.ParentEntity = this.ParentEntityObject;
						}
					}
					_entity.LogicalName = instance.GridEntityName;
					_entity.LocalAttributes = [];
					_attr.Schema = $("#"+instance.GridId+" #" + id).attr("data-schema");
					_attr.Value = $("#"+instance.GridId+" #" + id).val().substring(1);
					 if (_entityIndex == -1) {
						 _entity.LocalAttributes.push(_attr);
						 this.JsonData.push(_entity);
					} else {
						_attrIndex = PCHJS.Grid.CheckEntries(this.JsonData[_entityIndex].LocalAttributes, "Schema", _attr.Schema);
						if (_attrIndex == -1)
							this.JsonData[_entityIndex].LocalAttributes.push(_attr);
						else
							this.JsonData[_entityIndex].LocalAttributes[_attrIndex] = _attr;
					}
					this.TriggerAPICall(this.JsonData);
				},
				DatePushtoArray: function(event) {
					
				},
				StringPushtoArray: function(event, instance) {
					var id = event.currentTarget.id,
						_entity = {},
						_attr = {},
						_entityIndex = 0,
						_attrIndex = 0;

					if ($("#"+instance.GridId+" #" + id).closest('tr').attr("data-id")) {
						_entity.Request = "PATCH";
						_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "Id", _entity.Id);
					} else {
						_entity.Request = "POST";
						_entity.rowindex = $("#"+instance.GridId+" #" + id).closest('tr').attr("this.rowindex");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "rowindex", _entity.rowindex);
						if (!_entity.ParentEntity) {
							_entity.ParentEntity = instance.ParentEntityObject;
						}
					}
					_entity.LogicalName = instance.GridEntityName;
					_entity.LocalAttributes = [];
					_attr.FieldType = "string";
					_attr.Schema = $("#"+instance.GridId+" #" + id).attr("data-schema");
					_attr.Value = $("#"+instance.GridId+" #" + id).val();
					if (_entityIndex == -1) {
						_entity.LocalAttributes.push(_attr);
						instance.JsonData.push(_entity);
					} else {
						_attrIndex = PCHJS.Grid.CheckEntries(instance.JsonData[_entityIndex].LocalAttributes, "Schema", _attr.Schema);
						if (_attrIndex == -1)
						instance.JsonData[_entityIndex].LocalAttributes.push(_attr);
						else
						instance.JsonData[_entityIndex].LocalAttributes[_attrIndex] = _attr;
					}
				},
				IntegerPushtoArray: function(event) {
					
				},
				DecimalPushtoArray: function(event, instance) {
					var id = event.currentTarget.id,
						_entity = {},
						_attr = {},
						_entityIndex = 0,
						_attrIndex = 0;
					if ($("#"+instance.GridId+" #" + id).closest('tr').attr("data-id")) {
						_entity.Request = "PATCH";
						_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "Id", _entity.Id);
					} else {
						_entity.Request = "POST";
						_entity.rowindex = $("#"+instance.GridId+" #" + id).closest('tr').attr("this.rowindex");
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "rowindex", _entity.rowindex);
						if (!_entity.ParentEntity) {
							_entity.ParentEntity = instance.ParentEntityObject;
						}
					}
					_entity.LogicalName = instance.GridEntityName;
					_entity.LocalAttributes = [];
					_attr.FieldType = "decimal";
					_attr.Schema = $("#"+instance.GridId+" #" + id).attr("data-schema");
					_attr.Value = PCHJS.Common.Number.ToString( $("#"+instance.GridId+" #" + id).val(),2);
					if (_entityIndex == -1) {
						_entity.LocalAttributes.push(_attr);
						instance.JsonData.push(_entity);
					} else {
						_attrIndex = PCHJS.Grid.CheckEntries(instance.JsonData[_entityIndex].LocalAttributes, "Schema", _attr.Schema);
						if (_attrIndex == -1)
							instance.JsonData[_entityIndex].LocalAttributes.push(_attr);
						else
							instance.JsonData[_entityIndex].LocalAttributes[_attrIndex] = _attr;
					}
				},
				PicklistPushtoArray: function (event,instance) {
		
					var id = event.currentTarget.id, _entity = {}, _attr = {}, _entityIndex = 0, _attrIndex = 0;
		
					this.Validation.OverridenValidation(event);
					
					if ($("#"+instance.GridId+" #" + id).closest('tr').attr("data-id")) {
						_entity.Request = "PATCH";
						_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
						_entityIndex = PCHJS.Grid.CheckEntries(this.JsonData, "Id", _entity.Id);
					}
		
					else {
						_entity.Request = "POST";
						_entity.rowindex = $("#"+instance.GridId+" #" + id).closest('tr').attr("this.rowindex");
						_entityIndex = PCHJS.Grid.CheckEntries(this.JsonData, "rowindex", _entity.rowindex);
						if (!_entity.ParentEntity) {
							_entity.ParentEntity = instance.ParentEntityObject;
						}
					}
		
					_entity.Id = $("#"+instance.GridId+" #" + id).closest('tr').attr("data-id");
					_entity.LogicalName = instance.GridEntityName;
					_entity.LocalAttributes = [];
		
					_attr.FieldType = "picklist";
					_attr.Schema = $("#"+instance.GridId+" #" + id).attr("data-schema");
					_attr.Value = $("#"+instance.GridId+" #" + id).val();
					if (_entityIndex == -1) {
						_entity.LocalAttributes.push(_attr);
						this.JsonData.push(_entity);
					}
					else {
						_attrIndex = PCHJS.Grid.CheckEntries(this.JsonData[_entityIndex].LocalAttributes, "Schema", _attr.Schema);
						if (_attrIndex == -1)
							this.JsonData[_entityIndex].LocalAttributes.push(_attr);
						else
							this.JsonData[_entityIndex].LocalAttributes[_attrIndex] = _attr;
					}
				},
				BooleanPushtoArray: function(event) {
					
				},
				LookupPushtoArray: function(event) {
					
				},
				DeleteRowPushToArray: function($event, instance) {
					var _entity = {},
						_entityIndex = 0;

					if ($event.closest('tr').attr("data-id")) {
						_entity.Request = "DELETE";
						_entity.Id = $event.closest('tr').attr("data-id")
						_entityIndex = PCHJS.Grid.CheckEntries(instance.JsonData, "Id", _entity.Id);
					} else
						return;

					_entity.LogicalName = instance.GridEntityName;

					if (_entityIndex == -1)
						instance.JsonData.push(_entity);
					else
						instance.JsonData[_entityIndex] = _entity;
					
					instance.EnabelSaveAll();
				}
			},
			TriggerAPICall: function(request){
				var _url= ""; 
				var _data = {};
				var _apicallscounter = 0;
				var _entityref = {};
				var _localobject = this;
				if(request && request.length>0 && this.PCHEditableGridParentEntityMetaData){
					request.forEach((req) =>{
						if(req.LocalAttributes && req.LocalAttributes.length>0){
							req.LocalAttributes.forEach((attr) =>{
	console.log("---------> attr : " + JSON.stringify(attr));
	console.log("--> attr.FieldType : " + attr.FieldType);
	console.log("--> attr.Schema : " + attr.Schema);
								switch(attr.FieldType){
									case "string":
										_data[attr.Schema]= attr.Value;
										break;
									case "decimal":
									case "picklist":
									case "money":
										_data[attr.Schema]= new Number(attr.Value);
										break;
								}
	 console.log("--> _data : " + JSON.stringify(_data));                           
								if(req.ParentEntity && req.ParentEntity.RelationshipName){                                
									_data[this.PCHEditableGridParentEntityMetaData.OdataNavigation]="/"+this.PCHEditableGridParentEntityMetaData.ParentEntitySetName+"("+req.ParentEntity.Id+")"; 
	 console.log("--> _data 2: " + JSON.stringify(_data));                           
								}
							});
						}

						if(!req.Id)
							_url = "/_api/"+this.PCHEditableGridParentEntityMetaData.EntitySetName;
						else
							_url = "/_api/"+this.PCHEditableGridParentEntityMetaData.EntitySetName+"("+req.Id+")";

						this.CallAPI({
							type: req.Request,
							url: _url,
							contentType: "application/json",
							data: JSON.stringify(_data),
							success: function (data, textStatus, xhr) {
								if(xhr.status == 204){
									//console.log("**SUCCESS**");
								}
								_apicallscounter ++;
								if(_apicallscounter == request.length)
								_localobject.SubmissionErrorHandler(_localobject.GridId);
							}
							}).fail(function(response) {
								_apicallscounter ++;
								if (response.responseJSON) {
									console.error("Error: " + response.responseJSON.error.message)
								} else {
									console.error("Error: Web API is not available... ")
								}
								if(_apicallscounter == request.length)
								_localobject.SubmissionErrorHandler(_localobject.GridId,true);
							});
					_data = {};        
					});
				}
			},
			CallAPI: function (ajaxOptions, data){
				var deferredAjax = $.Deferred();
		
				shell.getTokenDeferred().done(function (token) {
					// add headers for AJAX
					if (!ajaxOptions.headers) {
						$.extend(ajaxOptions, {
							headers: {
								"__RequestVerificationToken": token
							}
						}); 
					} else {
						ajaxOptions.headers["__RequestVerificationToken"] = token;
					}
					$.ajax(ajaxOptions)
						.done(function(data, textStatus, jqXHR) {
							validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
						}).fail(deferredAjax.reject); //AJAX
				}).fail(function () {
					deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
				});
				return deferredAjax.promise();
			},
			Lookup: {
				GetDataCollection: function(entity, elementcallback, callbackindex) {
					
				},
				filterFunction: function(InputId) {
				   
				},
				PopulateDropDown: function(element, index) {
					
				},
				FocusIn: function(event) {
		
				},
				FocusOut: function(event) {
					////console.log("focus out target id " + event.target.id);
					//var dropdownid = event.target.id;
					//dropdownid = dropdownid.replace("td", "dropdown");
					////console.log("dropdownid " +dropdownid);
					//$("#dropdown_"+dropdownid).hide();
				},
				SetValue: function(event) {
					
				},
			},
			Validation: {
				isRequired: function (columnobject, index) {
					if (columnobject.Required == 2) {
						this.SetValidation(columnobject.LogicalName, index, columnobject.Name);
						return true;
					}
					return false;
				},
				SetValidation: function (field, index, columnlabel, columnindex) {
					this.Language = PCHJS.Grid.GetLanguage();
					var idofspan, fieldheader;
					if (!field || PCHJS.Grid.CheckEntries(Page_Validators, "id", "Custom" + field + index + "Validator") != -1)
						return;
					fieldheader = $("#"+this.GridId +" .view-grid").closest("table").find("th:eq(" + columnindex + ") label");
					if (fieldheader && !$("#header_" + field).attr("class") && typeof columnindex != 'undefined') {
						fieldheader.addClass("required");
						$("<strong id='header_" + field + "' class='required'>" + (this.Language == "1036" ? " (obligatoire) *" : " (required) *") +"</strong>").appendTo(fieldheader);
					}
					field = field + index;
					idofspan = document.getElementById("CustomRequiredFieldValidator" + field);
					if (!idofspan) {
						//$('#'+field+'_label').append('<span id='+"CustomRequiredFieldValidator"+field+" "+'style="color: #a94442;"> *</span>');
					}
					$("#CustomRequiredFieldValidator" + field).show();
					if (typeof (Page_Validators) == 'undefined') return;
					var value = $("#" + field).val();
					var label = $("#" + field).attr("aria-label");
					var rownumber = $("#"+field).closest("tr").index();
					label = label ? label : columnlabel;
					rownumber = rownumber != -1 ? rownumber : index;
					var newValidator = document.createElement('span');
					newValidator.style.display = "none";
					newValidator.id = "Custom" + field + "Validator";
					newValidator.controltovalidate = field;
					var message_en = '<a href=#' + field + '> The ' + label + " field in row number " + rownumber + " is a required field." + '</a>';
					var message_fr = '<a href=#' + field + '>' + 'Le champ ' + label + " à la ligne " + rownumber + " est obligatoire." + '</a>';
					newValidator.errormessage = this.Language == "1036" ? message_fr : message_en;
					newValidator.validationGroup = "";
					newValidator.initialvalue = "";
					_localobject = this;
					newValidator.evaluationfunction = function () {
						this.Language = PCHJS.Grid.GetLanguage();
						if(_localobject.GetValidationActualRowIndex(field) >-1){
							var message_en = '<a href=#' + field + '> The ' + label + " field in row number " + _localobject.GetValidationActualRowIndex(field) + " is a required field." + '</a>';
							var message_fr = '<a href=#' + field + '>' + 'Le champ ' + label + " à la ligne " + _localobject.GetValidationActualRowIndex(field) + " est obligatoire." + '</a>';
							this.errormessage = this.Language == "1036" ? message_fr : message_en;
						}
						if ($("#" + field).val())
							return true;
						else
							return false;
					};
					Page_Validators.push(newValidator);
					$("a[href=" + field + "]").on("click", function (field) {
						scrollToAndFocus(field + "_label", field);
					});
				},
				RemoveValidation: function (field) {
					if (!field)
						return;
					var i;
					for (i = 0; i < Page_Validators.length; i++) {
						if (typeof (Page_Validators[i].id) != 'undefined') {
							if (Page_Validators[i].id == "Custom" + field + "Validator" || Page_Validators[i].id == "Custom" + field + "DataValidator") {
								Page_Validators[i].evaluationfunction = true;
								$("#CustomRequiredFieldValidator" + field).hide();
							}
						}
					}
				},
				RemoveAllGridValidationOnCancel: function () {
					for (i = 0; i < Page_Validators.length; i++) {
						if (typeof (Page_Validators[i].id) != 'undefined') {
							if (Page_Validators[i].id.indexOf("Custom") != -1) {
								Page_Validators.splice(i);
								$("#ValidationSummaryEntityFormControl_EntityFormView").hide();
							}
						}
					}
				},
				SetDataValidation: function (field, index, columnlabel, datavalidationtype) {
					this.Language = PCHJS.Grid.GetLanguage();
					var _msg_en = " has invalid data", _msg_fr = " has invalid data", _datavalidationfunc;
					if (!field || PCHJS.Grid.CheckEntries(Page_Validators, "id", "Custom" + field + index + "DataValidator") != -1)
						return;
					
					field = field + index;
					idofspan = document.getElementById("CustomDataValidator" + field);
					if (typeof (Page_Validators) == 'undefined') return;
					var label = $("#" + field).attr("aria-label");
					var rownumber = $("#" + field).attr("this.rowindex");
					label = label ? label : columnlabel;
					rownumber = rownumber ? rownumber : index;
					var newValidator = document.createElement('span');
					newValidator.style.display = "none";
					newValidator.id = "Custom" + field + "DataValidator";
					newValidator.controltovalidate = field;

					if (typeof (datavalidationtype.MaxLength) != 'undefined') {
						_msg_en = "can not exceed the maximum length of " + datavalidationtype.MaxLength + " characters.";
						_msg_fr = "ne peut pas dépasser la longueur maximale de " + datavalidationtype.MaxLength + " caractères.";
						_datavalidationfunc = function () {
							var _val = $("#" + field).val();
							if (_val && _val.length > datavalidationtype.MaxLength)
								return false;
							else
								return true;
						}
					}
					else if (typeof (datavalidationtype.MaxValue) != 'undefined' && typeof (datavalidationtype.MinValue) != 'undefined') {
						_msg_en = "must have a value between " + datavalidationtype.MinValue + " and " + datavalidationtype.MaxValue + ".";
						_msg_fr = "doit avoir une valeur comprise entre " + datavalidationtype.MinValue + " et " + datavalidationtype.MaxValue + ".";
						$("#" + field).attr("max",datavalidationtype.MaxValue);
						$("#" + field).attr("min",datavalidationtype.MinValue);
						$("#" + field).css("width","100%");
						_datavalidationfunc = function () {
							if(!$("#" + field).val())
								return true;
							_val = $("#" + field).val().replace("$","");
							if (_val && _val > datavalidationtype.MaxValue || _val < datavalidationtype.MinValue)
								return false;
							else
								return true;
						}
					}
					else if (typeof (datavalidationtype.MinValue) != 'undefined') {
						_msg_en = "can not be less than " + datavalidationtype.MinValue;
						_msg_fr = "ne peut pas être inférieur à " + datavalidationtype.MinValue;
						_datavalidationfunc = function () {
							if (_val && _val < datavalidationtype.MinValue)
								return false;
							else
								return true;
						}
					}
					var message_en = '<a href=#' + field + '> The ' + label + " field in row number " + rownumber + " " + _msg_en + '</a>';
					var message_fr = '<a href=#' + field + '>' + 'Le champ ' + label + " à la ligne " + rownumber + " " + _msg_fr + '</a>';
					newValidator.errormessage = this.Language == "1036" ? message_fr : message_en;
					newValidator.validationGroup = "";
					newValidator.initialvalue = "";
					newValidator.evaluationfunction = _datavalidationfunc;
					Page_Validators.push(newValidator);
					$("a[href=" + field + "]").on("click", function (field) {
						scrollToAndFocus(field + "_label", field);
					});
				},
				OverridenValidation: function(event){
					var _fieldid = event.target.id;
					var _index = $("#"+_fieldid).closest("tr").index()+1;
					if($("#"+_fieldid).val() && $("#"+_fieldid).val() == 10){
						var _other = '<input type="text" id="'+_fieldid+'_text'+_index+'" this.rowindex="'+_index+'" aria-label="Total" placeholder="Other:" data-type="Microsoft.Xrm.Sdk.String" onchange="this.Save.StringPushtoArray(event);" data-schema="pch_expenseitem" class="text form-control required" value="" style="margin-top: 5px;">';
						$(_other).insertAfter($("#"+_fieldid));
						this.Validation.SetValidation(_fieldid+"_text", _index, "Other");
					}
					else{
						if($("#"+_fieldid).siblings("input").length>0){
							$("#"+_fieldid).siblings("input").remove();
							this.Validation.RemoveValidation(_fieldid+"_text"+_index);
						}
					}
				},
				GetValidationActualRowIndex: function (fieldid){
					var _actualindex = -1;
					$("#"+fieldid).closest("table").find("tbody tr:visible").each(function(_index){
						if($(this).find("#"+fieldid) && $(this).find("#"+fieldid).length && $(this).find("#"+fieldid).length>0 ){
							_actualindex = _index+1;
						}
					});
					console.log("*****_actualindex********");
					console.log(_actualindex);
					return _actualindex;
				}
			}
		}
		},
		this.CheckEntries= function(_obj, key, value) {
			var i = 0;
			for (i = 0; i < _obj.length; i++) {
				if (_obj[i][key] === value) {
					return i;
				}
			}
			return -1;
		},
		this.GetLanguage = function (){
			var _link = document.location.href.split('/');
			var _lang = _link[3];
			return _lang == "en-CA" ? 1033 : 1036;
		}
	}).call(PCHJS.Grid);
	////////////////////////Webapi initializer///////////////////////////////////////////////
	//WEBAPI init
		(function(webapi, $){
				function safeAjax(ajaxOptions) {
					var deferredAjax = $.Deferred();
					shell.getTokenDeferred().done(function (token) {
						// add headers for AJAX
						if (!ajaxOptions.headers) {
							$.extend(ajaxOptions, {
								headers: {
									"__RequestVerificationToken": token
								}
							}); 
						} else {
							ajaxOptions.headers["__RequestVerificationToken"] = token;
						}
						$.ajax(ajaxOptions)
							.done(function(data, textStatus, jqXHR) {
								validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
							}).fail(deferredAjax.reject); //AJAX
					}).fail(function () {
						deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
					});
			
					return deferredAjax.promise();	
				}
				webapi.safeAjax = safeAjax;
			})(window.webapi = window.webapi || {}, jQuery);
	PCHJS.Common.WebAPI = {};
	PCHJS.Common.WebAPI.GetJobTitleFromContactId = async contactId =>  webapi.safeAjax(	{ type: "GET", url: `/_api/contacts(${contactId})?$select=jobtitle`,contentType: "application/json" });
	
	PCHJS.Common.WebAPI.patchSingle = async (tableName, recordGuid, patchJson, successFn=(res, status, xhr)=>{}, failureFn=(res, status, xhr)=>{} ) => 
		webapi.safeAjax({ type: "PATCH", url: `/_api/${tableName}(${recordGuid})`, contentType: "application/json", data: JSON.stringify(patchJson), success:successFn, fail:failureFn });	
	PCHJS.Common.WebAPI.postSingle = async (tableName, recordGuid, postJson, successFn=(res, status, xhr)=>{}, failureFn=(res, status, xhr)=>{} ) =>  
		webapi.safeAjax({ type: "POST", url: `/_api/${tableName}(${recordGuid})`, contentType: "application/json", data: JSON.stringify(postJson), success:successFn, fail:failureFn });
	PCHJS.Common.WebAPI.deleteSingle = async (tableName, recordGuid, successFn=(res, status, xhr)=>{}, failureFn=(res, status, xhr)=>{} ) =>  
		webapi.safeAjax({ type: "DELETE", url: `/_api/${tableName}(${recordGuid})`, contentType: "application/json",  success:successFn, fail:failureFn });
		
	PCHJS.Common.WebAPI.GetRecords = async(tableNamePlural, selectList, odataFilter="") => {
		let webUrl = `/_api/${tableNamePlural}?$select=${selectList}`;
		if(odataFilter != "")
			webUrl = webUrl + `&$filter=${odataFilter}`
		return webapi.safeAjax(	{ type: "GET", url: webUrl,contentType: "application/json" });
	}		
	// OnLoad function to replicate top-of-the-page validation messages along with input fields. 
	$(document).ready(
		()=>{
			const validationSummaryNode = document.getElementsByClassName("validation-summary")[0];
			if(validationSummaryNode)
			{
				const config = { attributes: false, childList: true, subtree: false };
				const callback = (mutationList, observer) => {  
					$(".alert.alert-error.context-alert-danger").remove();
					$("li a", $(validationSummaryNode)).each(
						function()
						{
							let $infoDiv = $($(this).attr("href")).closest("div.info");
							if($infoDiv.length==0)
							{
								$infoDiv = $($(this).attr("href")).closest("td").find("div.info");
							}
							const errorText = $(this).text();
							const $contextErrorDiv = $("<div class='alert alert-error context-alert-danger'>");
							$contextErrorDiv.text(errorText);
							const isCheckbox = $infoDiv.closest("td").is(".checkbox-cell");
							if(isCheckbox)
							{
								$infoDiv.before($contextErrorDiv);
							}
							else
							{
								if($infoDiv.length>0)
								{
								  $infoDiv.after($contextErrorDiv);
								}
								else
								{
								  $($(this).attr("href")).before($contextErrorDiv);
								}
							}
							
						}
					);
				};
				const observer = new MutationObserver(callback);
				observer.observe(validationSummaryNode, config);
				
				$("#liquid_form :input").change(
					function() {
						$(this).closest("td").find(".context-alert-danger").remove();
						
					}
				);
				$("#liquid_form :input").closest(".datetimepicker").on("click",
					function() {
						
						$(this).closest("td").find(".context-alert-danger").remove();
						
					}
				);
			}
		}
	);
	//Onload function for application delete functionality
	$(document).ready(
		()=>{
			if($(".weblinks a.weblink.active:last-child").length == 1)//i.e. if current active page is the last one in left side navigation i.e. Final Review page
			{
				if(g_submissionStatus == 370410003 && g_submissionVersion == 1 && g_submissionType != 798290001)  //Status = Draft And Version = 1 And Submission Type <> Final Report
				{
					const locale = PCHJS.Common.CurrentLang == "FR"?"fr-CA":"en-CA";
					const deleteLabel = PCHJS.Common.CurrentLang == "FR"?"Supprimer":"Delete";
					
					const confirmDeleteTitle = PCHJS.Common.CurrentLang == "FR"?"Voulez-vous vraiment supprimer cette ébauche?":"Are you sure you want to delete?";
					const confirmDeletebody = PCHJS.Common.CurrentLang == "FR"?"Vous ne pourrez pas la récupérer.":"You will not be able to recover this draft.";
					const cancelLabel = PCHJS.Common.CurrentLang == "FR"?"Annuler":"Cancel";
					const $deleteModalExternal = $(
					`<div class='modal fade' id='appDeleteModal' tabindex='-1' role='dialog' aria-labelledby='Application-Delete'>
						<div class='modal-dialog' role='document'>
							<div class='modal-content'>
								<div class='modal-header'>
									<button type='button' class='close' data-dismiss='modal' aria-label='Close'>
										<span aria-hidden='true'>&times;</span>
									</button>
									<h4 class='modal-title' id='Application-Delete'>${confirmDeleteTitle}</h4>
								</div>
								<div class='modal-body'>${confirmDeletebody}</div>
								<div class='modal-footer'>
									<button type='button' class='btn btn-default' data-dismiss='modal'>${cancelLabel}</button>
									<button data-dismiss='modal' id='appDeleteConfirmBtn' class='remove btn btn-primary' type='button' >${deleteLabel}</button>
								</div>
							</div>
						</div>
					</div>`);
						
					const $deleteBtn = $("<button type='button' data-toggle='modal' data-target='#appDeleteModal'>");
					$deleteBtn.attr("aria-label",deleteLabel).text(deleteLabel);
					$deleteBtn.css("margin-right","5px").addClass("btn").addClass("btn-danger");
					
					$(".form-action-container-right").prepend($deleteBtn);
					$(".form-action-container-right").prepend($deleteModalExternal);
					
					$("#appDeleteConfirmBtn").click(()=>{
						webapi.safeAjax({
							type: "PATCH",
							url: `/_api/core_fc_submissions(${g_submissionId})`,
							contentType: "application/json",
							data: "{'pch_isdeleted':true}",
							success: function (data, textStatus, xhr) {
								//console.log("Record updated");
								//{{ sitemarkers['My applications'].url | escape }}
								window.location.href = `/${locale}/my-applications`;
							},
							error: function (xhr, textStatus, errorThrown) {
								console.log(xhr);
							}
						});
					});
				}
						
				/*
				const finalReviewUrl = new URL(location.href);
				const submissionId = finalReviewUrl.searchParams.get("application_id")??finalReviewUrl.searchParams.get("id");
				webapi.safeAjax(
				{
					type: "GET",
					url: `/_api/core_fc_submissions(${submissionId})?$select=statuscode,pch_submissiontype,pch_version`,
					contentType: "application/json", 
					success: function (res) 
					{
						if(res.statuscode == 370410003 && res.pch_version == 1 && res.pch_submissiontype != 798290001)  //Status = Draft And Version = 1 And Submission Type <> Final Report
						{
							const locale = PCHJS.Common.CurrentLang == "FR"?"fr-CA":"en-CA";
							const deleteLabel = PCHJS.Common.CurrentLang == "FR"?"supprimer":"Delete";
							
							const confirmDeleteTitle = PCHJS.Common.CurrentLang == "FR"?"Voulez-vous vraiment supprimer cette ébauche?":"Are you sure you want to delete?";
							const confirmDeletebody = PCHJS.Common.CurrentLang == "FR"?"Vous ne pourrez pas la récupérer.":"You will not be able to recover this draft.";
							const cancelLabel = PCHJS.Common.CurrentLang == "FR"?"Annuler":"Cancel";
							const $deleteModalExternal = $(
							`<div class='modal fade' id='appDeleteModal' tabindex='-1' role='dialog' aria-labelledby='Application-Delete'>
								<div class='modal-dialog' role='document'>
									<div class='modal-content'>
										<div class='modal-header'>
											<button type='button' class='close' data-dismiss='modal' aria-label='Close'>
												<span aria-hidden='true'>&times;</span>
											</button>
											<h4 class='modal-title' id='Application-Delete'>${confirmDeleteTitle}</h4>
										</div>
										<div class='modal-body'>${confirmDeletebody}</div>
										<div class='modal-footer'>
											<button type='button' class='btn btn-default' data-dismiss='modal'>${cancelLabel}</button>
											<button data-dismiss='modal' id='appDeleteConfirmBtn' class='remove btn btn-primary' type='button' >${deleteLabel}</button>
										</div>
									</div>
								</div>
							</div>`);
								
							const $deleteBtn = $("<button type='button' data-toggle='modal' data-target='#appDeleteModal'>");
							$deleteBtn.attr("aria-label",deleteLabel).text(deleteLabel);
							$deleteBtn.css("margin-right","5px").addClass("btn").addClass("btn-danger");
							
							$(".form-action-container-right").prepend($deleteBtn);
							$(".form-action-container-right").prepend($deleteModalExternal);
							
							$("#appDeleteConfirmBtn").click(()=>{
								webapi.safeAjax({
									type: "PATCH",
									url: `/_api/core_fc_submissions(${submissionId})`,
									contentType: "application/json",
									data: "{'pch_isdeleted':true}",
									success: function (data, textStatus, xhr) {
										//console.log("Record updated");
										//{{ sitemarkers['My applications'].url | escape }}
										window.location.href = `/${locale}/my-applications`;
									},
									error: function (xhr, textStatus, errorThrown) {
										console.log(xhr);
									}
								});
							});
						}
					},
					error: function(res){
						console.log("error: " + res);
						return false;
					}       
				});
				*/
				
			}
		}
	);
	//dirty flag handler to show exit-modal
	$(document).ready(
	()=>
	{
		setTimeout(()=>
		{
			if($("div.exit-modal").length == 0)
			{
				let changesMade = false;
				const handleClickEvent = (e) => {
				  if (changesMade || $(".dirty").length > 0) {
					  $('.exit-modal').attr("style", "display: block;");
					  $('#exit-link').attr("href", e.currentTarget.getAttribute('href'))
					  return false;
				  }
				};
				const exitPromptTitle = PCHJS.Common.CurrentLang != "FR"? "Leave page without saving?":"Quitter la page sans sauvegarder?";
				const exitPromptMessage = PCHJS.Common.CurrentLang != "FR"? "If you do not save this page before leaving, you will lose your work.":"Si vous ne sauvegardez pas cette page avant de la quitter, vous perdrez votre travail.";
				const globalWarningContinue = PCHJS.Common.CurrentLang != "FR"? "Continue without saving":"Continuer sans sauvegarder";
				const globalCancel = PCHJS.Common.CurrentLang != "FR"? "Cancel":"Annuler";
				
				$(".entity-form").append("<div class='exit-modal'><div class='exit-modal-content'><h4 class='modal-title'>" + exitPromptTitle + "</h4><p>" + exitPromptMessage + "</p><div id='modal-buttons'><a id='exit-link' class='btn btn-secondary'>" + globalWarningContinue + "</a><button id='exit-close' class='btn btn-primary'>" + globalCancel + "</button></div></div></div>")

				$("select, input, textarea").change(() => {
					changesMade = true;
				});

				$("a[rel='prev'], a[rel='next'], a.list-group-item, nav.gc-subway li a").click((e) => {
					return handleClickEvent(e)
				});


				
				$('#exit-close').click(() => {
					$('.exit-modal').hide()
					return false;
				});
			}
		},2000);
	});
	
	$(document).ready(()=>{
		const selectDateTooltip = PCHJS.Common.CurrentLang == "FR"? "Choisir une date":"Choose a date";
		$("div.datetimepicker .input-group-addon").attr("title",selectDateTooltip);
		
		var dateTimeObserverList = [];
		var dateTimeObservePropertyChangeStarted = false;
		function dateTimeObservePropertyChange(input, propertyName, callback) {
			dateTimeObserverList.push({
				 input: input,
				 propertyName: propertyName,
				 state: input[propertyName],
				 callback: callback
			});
			if (!dateTimeObservePropertyChangeStarted) {
				dateTimeObservePropertyChangeStarted = true;
				setInterval(_ => {
					for (const obj of dateTimeObserverList) {
						const state = obj.input[obj.propertyName];
						if (state !== obj.state) {
							obj.state = state;
							obj.callback(obj.input);
						}
					}
				}, 100);
			}
		}

		$("div.datetimepicker>input").each((i,elem)=>{
			const observer = new MutationObserver(function(mutations) {
				mutations.forEach(function(mutation) {
					//var attributeValue = $(mutation.target).prop(mutation.attributeName);
					//console.log("Class attribute changed to:", attributeValue);
					if($(mutation.target).hasClass("dirty"))
					{
						//setTimeout(()=>{
							const dateTimeInput = $(mutation.target).closest("div.datetimepicker").siblings("input[data-ui=datetimepicker]")[0];
							dateTimeObservePropertyChange(dateTimeInput , 'value', (target) => { 
								$(target).trigger("change");
							});
							$(dateTimeInput).trigger("change");
						//},400);
					}
				});
			});

			observer.observe(elem, {
			  attributes: true,
			  attributeFilter: ['class']
			});
		});
	});
}
